#ifndef gBHTTP_X_H
#define gBHTTP_X_H

#include "ghttp.h"
#include "gBNetHttpRequest.h"
////////////////////////////////////////////////////////////
class gXHttpReplyHeader : public gList {
public:
    gXHttpReplyHeader () ;
    virtual ~gXHttpReplyHeader () {
    }

    // Public data-members
    int htmlCode;
    gString sHtmlCode;  // (e.g. "Not Found")
    gList kindsL;
    gList linesL;

    // I/O methods
    virtual bool IsText () ;
    virtual bool IsChunked () {
	return isTransferEncodingChunked;
    }

    virtual bool GetLine (char* sKind, gString& sResult) ;
    virtual bool AddLine (gString& s) ;
    virtual t_uint32 GetLength (bool& hasFound, bool& isLengthOk) ;

    virtual bool IsCodeNotFound () {
	return htmlCode>=400 && htmlCode<500;
    }
    virtual bool IsCodeRedirect () {
	return htmlCode>=300 && htmlCode<400;
    }

protected:
    bool isTransferEncodingChunked;

    int thisAddLine (char* sKind, char* sContent) ;
    int thisAddLine (gString& sKind, gString& sContent) ;

private:
    // Operators,empty
    gXHttpReplyHeader (gXHttpReplyHeader& ) ; //empty
    gXHttpReplyHeader& operator= (gXHttpReplyHeader& ) ; //empty
};
////////////////////////////////////////////////////////////
class gXHttpGeneric : public gHttpGeneric {
public:
    virtual ~gXHttpGeneric () ;

    // Public data-members
    int ioOpErrCode;
    gList getHeaderL;  // merely the written header
    gList strHeaderL;  // strings to add between 'Host:' and 'User-Agent:'
    gXHttpReplyHeader replyHeader;
    gHttpRequestList lReq;

    t_uint64 contentBytesRead;
    t_uint64 totalBytesRead;
    const static short nStat=4;
    gUInt vStat[nStat];
    int keepAliveTimeout;  // in seconds
    int keepAliveMax;  // in seconds
    FILE* fRepErr;

    // Get methods
    virtual gBigBuffer& GetBuffer () ;
    virtual gUCharBuffer& GetBaseBuffer () ;
    virtual gString& GetProtocolString () ;
    virtual gVersion& GetVersion () ;

    virtual gTcpConnect& Connection () ;
    virtual gTcpConnect* ConnectionPtr () ;

    virtual bool GetContent (eContentMethod method,
			     gString& sHost,
			     gString& sPath,
			     gString& sReply) ;

    // Set methods
    virtual bool SetProtocolVersion (char* str) ;

    virtual int AddHead (gString& s, bool doCrNl=true) ;
    virtual int AddHeadStr (char* str) ;
    virtual int WriteHead (bool doFlush=false) ;

    // Special methods
    virtual int SecSleep (t_uint32 aSec) ;
    virtual int MiliSecSleep (t_uint32 aMiliSec) ;

protected:
    gXHttpGeneric (gTcpConnect& connection) ;

    gBigBuffer* pBuf;
    gTimerTic mStat[nStat];  // For stats

    int thisReadHeadReply (gTcpConnect& connection, unsigned& count, gString& sResult) ;

    int thisParseServerReply (gString& sReply, gXHttpReplyHeader& serverReply) ;

private:
    gVersion httpVersion;
    gString sProtocol;
    gString sProtoVersion;

    // Operators,empty
    gXHttpGeneric (gXHttpGeneric& ) ; //empty
    gXHttpGeneric& operator= (gXHttpGeneric& ) ; //empty
};
////////////////////////////////////////////////////////////
class gXHttpCont : public gXHttpGeneric {
public:
    gXHttpCont (gTcpConnect& connection) ;
    virtual ~gXHttpCont () ;

    // Public members
    gString strUserAgent;

    // Get methods
    virtual bool IsText () {
	return isContText;  //Content-Type: Text...
    }

    virtual bool GetContent (eContentMethod method,
			     gString& sHost,
			     gString& sPath,
			     gString& sReply) ;

    virtual char* GetHeadUserAgentStr () ;
    virtual char* GetHeadRefererStr () ;

protected:
    bool isContText;
    gString sHostname;
    gString sHeadTempStr;

    virtual int ReadReplyText (gTcpConnect& connection, eContentImport contImport, gBigBuffer& bBuf, unsigned& count) ;
    virtual int ReadReplyBin (gTcpConnect& connection, gBigBuffer& bBuf, unsigned& count) ;

    virtual int ReadReplyUnsized (gTcpConnect& connection, eContentImport contImport, gBigBuffer& bBuf, unsigned& count) ;
    virtual int ReadReplyChunked (gTcpConnect& connection, gBigBuffer& bBuf, unsigned& count) ;

    t_uint32 thisReadChunkSize (gTcpConnect& connection, int& error) ;

    int thisGetHtmlContrl (eContentMethod method,
			   gString& sPath,
			   gString& sReply) ;

private:
    // Operators,empty
    gXHttpCont (gXHttpCont& ) ; //empty
    gXHttpCont& operator= (gXHttpCont& ) ; //empty
};
////////////////////////////////////////////////////////////
#endif //gBHTTP_X_H

