// gBNetHttpRequest.cpp -- Version 2.8

#include "gBNetHttpRequest.h"
////////////////////////////////////////////////////////////
gHttpRequestList::gHttpRequestList ()
    : iContentLength( -1 )
{
}

unsigned gHttpRequestList::FindHeadFirst (char* colonStr)
{
 gString sColon;
 thisAdjustColonStr( colonStr, sColon );
 return
     FindFirst( sColon.Str(), 1, e_FindExactPosition );
}

unsigned gHttpRequestList::FindHeadFullFirst (char* fullStrWithColon)
{
 unsigned pos;
 gString sColon;
 thisAdjustColonStr( fullStrWithColon, sColon );
 pos = sColon.Find( ": " );
 if ( pos==0 ) return 0;
 ASSERTION(pos,"pos");
 sColon[ pos+2 ] = 0;
 DBGPRINT("DBG: FindHeadFullFirst('%s'): '%s'\n",
	  fullStrWithColon,
	  sColon.Str());
 return
     FindFirst( sColon.Str(), 1, e_FindExactPosition );
}

gHttpRequestList& gHttpRequestList::CopyRequest (gHttpRequestList& lReq)
{
 iContentLength = lReq.iContentLength;
 CopyList( lReq );
 lText.CopyList( lReq.lText );
 return *this;
}

bool gHttpRequestList::Consolidate ()
{
 gString sFirstTextLine( lText.Str(1) );
 t_int32 iLengthTry = (t_int32)sFirstTextLine.Length();
 long len = (long)iLengthTry;

 if ( iContentLength<=-1 ) {
     if ( iLengthTry<=0 ) return false;
     gString s( 100, '\0' );
     snprintf( s.Str(), 100, "Content-Length: %ld", len );
     Add( s );
     iContentLength = iLengthTry;
 }

 return true;
}

int gHttpRequestList::thisAdjustColonStr (char* colonStr, gString& sColon)
{
 // Refer to: http://en.wikipedia.org/wiki/Colon_%28punctuation%29
 ASSERTION(colonStr,"colonStr");
 sColon.Set( colonStr );
 if ( sColon[ sColon.Length() ]!=':' )
     return 0;
 sColon.Add( ' ' );
 return 1;
}
////////////////////////////////////////////////////////////

