#ifndef gHTML_CTRL_X_H
#define gHTML_CTRL_X_H

#include "gHtmlParser.h"
#include "gHtmlLog.h"

// Some macros

// --- Debug Macros

#ifdef DEBUG_WEB1   // Checker&Consolidation, Parsing Trees blocks
#define DBGPRINT_WEB1(args...) printf(args)
#else
#define DBGPRINT_WEB1(args...) ;
#endif //DEBUG_WEB1

#ifdef DEBUG_WEB2   // Parsing Trees details
#define DBGPRINT_WEB2(args...) printf(args)
#else
#define DBGPRINT_WEB2(args...) ;
#endif //DEBUG_WEB2

#ifdef DEBUG_WEB3   // Parser tidying, etc
#define DBGPRINT_WEB3(args...) printf(args)
#else
#define DBGPRINT_WEB3(args...) ;
#endif //DEBUG_WEB3

#ifdef DEBUG_WEBA1   // (e.g. attributes)
#define DBGPRINT_WEBA1(args...) printf(args)
#else
#define DBGPRINT_WEBA1(args...) ;
#endif //DEBUG_WEBA1

#ifdef DEBUG_WEBA2   // (attributes in detail)
#define DBGPRINT_WEBA2(args...) printf(args)
#else
#define DBGPRINT_WEBA2(args...) ;
#endif //DEBUG_WEBA2

// --- Log Macros

#define HTML_LOG(args...) gHtmlCtrl::Self().hLog.Log(args)

////////////////////////////////////////////////////////////
class gHtmlCtrl {
public:
    virtual ~gHtmlCtrl () ;
    static gHtmlCtrl& Self () {
	return myself;
    }

    gHtmlLog hLog;

    // Get methods
    virtual gHtmlParser* ParserPtr () {
	Init();
	return parserPtr;
    }

    // Set methods
    virtual int Init () ;
    virtual void ReleaseHash () ;

protected:
    gHtmlCtrl () ;

private:
    static gHtmlCtrl myself;
    static gHtmlParser* parserPtr;

    // Operators,empty
    gHtmlCtrl (gHtmlCtrl& ) ; //empty
    gHtmlCtrl& operator= (gHtmlCtrl& ) ; //empty
};
////////////////////////////////////////////////////////////
#endif //gHTML_CTRL_X_H

