#ifndef gHTML_HATTR_X_H
#define gHTML_HATTR_X_H

#include "glistext.h"
#include "gcontrol.h"
#include "gHtmlHATypes.h"
////////////////////////////////////////////////////////////
class gHAttrValue : public gString {
    // Contains a pair: 'string Left value (the DTD attribute name)' and the value itself.
public:
    gHAttrValue (char* strL, gHAType* pValue) ;
    virtual ~gHAttrValue () ;

    virtual gHAType& GetValue () ;
    virtual gHAType* GetValuePtr () ;

protected:
    gHAType* valuePtr;  // never allocated here

private:
    // Operators,empty
    gHAttrValue (gHAttrValue& ) ; //empty
    gHAttrValue& operator= (gHAttrValue& ) ; //empty
};
////////////////////////////////////////////////////////////
class gHAttrs : public gList {
public:
    gHAttrs () ;
    virtual ~gHAttrs () ;

    // Get methods
    virtual bool IsOk () ;

    virtual gHAttrValue& GetAttrValue (unsigned idx) ;
    virtual gHAttrValue* GetAttrValuePtr (unsigned idx) ;

    virtual gHAType& GetAttr (unsigned idx) ;
    virtual gHAType* GetAttrPtr (unsigned idx) ;

    sHAttrType* TypeName2HAttrType (char* strType) ;
    int TypeEnumToSmartL (sHAttrType* pAttrType, gSmartList& lEnumResult) ;

    // Set methods
    virtual void Reset () ;

    virtual int BuildFromLRLists (char* strTag, gList& lLVal, gList& lRVal, bool addOnError, unsigned iLine) ;

    // Special methods
    virtual gHAType* NewType (char* strValue, sHAttrType* hAttrType) ;

    // Show methods
    virtual void Show (bool doShowAll=true) ;

private:
    // Operators,empty
    gHAttrs (gHAttrs& ) ; //empty
    gHAttrs& operator= (gHAttrs& ) ; //empty
};
////////////////////////////////////////////////////////////
#endif //gHTML_HATTR_X_H

