// gHtmlSeq, part of gUnweb

#include "gHtmlSeq.h"
#include "gHtmlCtrl.h"
////////////////////////////////////////////////////////////
gTagTree::gTagTree (char* descStr)
    : mCoord( -1 ),
      myTree( nil )
{
 if ( descStr!=nil ) sDesc.Set( descStr );
}

gTagTree::~gTagTree ()
{
 // Delete myTree not performed, because tree should be added somewhere-else!
}

char* gTagTree::Str ()
{
 return sDesc.Str();
}

void gTagTree::Reset ()
{
 mCoord = -1;
 myTree = nil;  // not allocated
 gTagCoord::Reset();
}
////////////////////////////////////////////////////////////
/* ---
gHTrElem::gHTrElem ()
    : ptrBlock( nil ),
      nextNode( nil )
{
}

gHTrElem::~gHTrElem ()
{
 // Not a gStorage behaviour: the ptrBlock is not copied, but deleted by this gHTrElem...!
 delete ptrBlock;
}

char* gHTrElem::GetStr ()
{
 ASSERTION(ptrBlock!=nil,"ptrBlock!=nil");

 sOutTr.SetEmpty();

 if ( ptrBlock->IsTag() ) {
     sOutTr.Set( "[" );
     sOutTr.Add( ptrBlock->GetTagPtr()->GetStr() );
     gString sTemp( 10, '\0' );
     sprintf(sTemp.Str(),":idTag=%d",ptrBlock->GetTagPtr()->idTag);
     sOutTr.AddString( sTemp );
     sOutTr.Add( "]" );
 }

 unsigned i, n = ptrBlock->N();
 if ( n>0 ) sOutTr.Add( '{' );
 for (i=1; i<=n; i++) {
     sOutTr.Add( ptrBlock->Str( i ) );
     if ( i<n ) sOutTr.Add( '#' );
 }
 if ( n>0 ) sOutTr.Add( '}' );

 return sOutTr.Str();
}
--- */
////////////////////////////////////////////////////////////
gHNode::gHNode ()
    : nextNode( nil ),
      tSub( nil ),
      pCouple( nil )
{
}

gHNode::~gHNode ()
{
 delete tSub;
 tSub = nil;
}

gHtmlCouple* gHNode::GetCouple ()
{
 ASSERTION(pCouple!=nil,"pCouple!=nil");
 return pCouple;
}

bool gHNode::SetCouplePtr (gHtmlCouple* ptrCouple)
{
 ASSERTION(ptrCouple!=nil,"ptrCouple!=nil");
 pCouple = ptrCouple;
 return ptrCouple!=nil;
}
////////////////////////////////////////////////////////////
gHTree::gHTree ()
    : pStart( nil ),
      pEnd( nil )
{
}

gHTree::~gHTree ()
{
 Reset();
}

gHNode* gHTree::GetLastNode ()
{
 ASSERTION(pEnd!=nil,"pEnd!=nil");
 return pEnd;
}

void gHTree::Reset ()
{
 gHNode* pMark, *pNextElem;

 gList::Reset(); //Actually no op...
 for (pMark=pStart; pMark!=nil; ) {
     pNextElem = pMark->nextNode;
     delete pMark;
     pMark = pNextElem;
 }
 pStart = pEnd = nil;
}

int gHTree::AppendCouplePtr (gHtmlCouple* ptrCouple)
{
 ASSERTION(ptrCouple!=nil,"ptrCouple!=nil");
 if ( ptrCouple->coupleId>-1 ) return -1;
 ptrCouple->coupleId = 0;
 gHNode* newNode = new gHNode;
 ASSERTION(newNode!=nil,"newNode!=nil");
 newNode->SetCouplePtr( ptrCouple );
#ifdef DEBUG_WEBX
 gString sDbgStr;
 if ( ptrCouple->IsText() ) {
     ptrCouple->pHStr->ConvertAmpToAscii( ptrCouple->GetStr(), sDbgStr );
 }
 DBGPRINT_WEB3("DBG: AppendCouple:[%s:%s:%u]\n",ptrCouple->GetStr(),sDbgStr.Str(),ptrCouple->N());
#endif
 thisAppendNode( newNode );
 return 0;
}

int gHTree::AppendTreePtr (gHTree* pTree)
{
 gHNode* newNode = new gHNode;
 ASSERTION(newNode!=nil,"newNode!=nil");
 newNode->tSub = pTree;
 thisAppendNode( newNode );
 return 0;
}

int gHTree::thisAppendNode (gHNode* newNode)
{
 ASSERTION(newNode!=nil,"newNode!=nil");
 if ( pEnd==nil ) {
     pStart = pEnd = newNode;
 }
 else {
     pEnd->nextNode = newNode;
     pEnd = newNode;
 }
 return 0;
}

int gHTree::thisShowNode (gHNode* pNode, bool doShowAll, int level)
{
 gHtmlCouple* pCouple;
 if ( pNode==nil ) return -1;
 pCouple = pNode->GetCouplePtr();

 char sMyFmt[ 100 ];
 sprintf(sMyFmt,"%%%ds(%d)",level*4,level);

 printf(sMyFmt," ");
 if ( pCouple==nil ) {
     printf("_\n");
     return 0;
 }
 printf(": {%s}\n",pCouple->GetStrForTree());
 return 0;
}

void gHTree::Show (bool doShowAll)
{
 DBGPRINT("gHTree::Show: START\n");
 ShowTree( doShowAll, 0 );
 DBGPRINT("gHTree::Show: END\n");
}

void gHTree::ShowTree (bool doShowAll, int level)
{
 gHNode* pNode = pStart;
 char sMyFmt[ 100 ];

 sprintf(sMyFmt,"%%%ds(%d)<<:\n",level*4,level);
 if ( level>0 && doShowAll==true ) printf(sMyFmt," ");
 for ( ; pNode!=nil; ) {
     thisShowNode( pNode, doShowAll, level );
     if ( pNode->tSub!=nil )
	 pNode->tSub->ShowTree( doShowAll, level+1 );
     pNode = pNode->nextNode;
 }
 sprintf(sMyFmt,"%%%ds(%d)>>.\n",level*4,level);
 if ( level>0 && doShowAll==true ) printf(sMyFmt," ");
}
////////////////////////////////////////////////////////////
gHSeq::gHSeq (FILE* afRepErr)
    : fRepErr( afRepErr ),
      baseURI( gURI::e_http ),
      nCoords( 0 ),
      iCoordStt( 0 ),
      pTagCoords( nil ),
      nTagTree( 0 ),
      pTagTree( nil )
{
}

gHSeq::~gHSeq ()
{
 if ( pTagCoords!=nil ) delete[] pTagCoords;

#ifdef DEBUG
 for (int pIdx=1; pIdx<=nTagTree; pIdx++) {
     printf("DBG: TagTree %d/%d: %d: %s\n",pIdx,nTagTree,pTagTree[pIdx].GetY(),pTagTree[pIdx].Str());
 }
#endif //DEBUG_...

 if ( pTagTree!=nil ) delete[] pTagTree;
}

char* gHSeq::GetURL (char* strURI)
{
 gURI::ePathType pathTypeAnchor, pathTypeBase;

 if ( strURI==nil ) return nil;

 gURI aURI;
 aURI.SetString( strURI );
 pathTypeAnchor = aURI.GetPathType();
 if ( pathTypeAnchor==gURI::e_NoType ) return nil;

 pathTypeBase = baseURI.GetPathType();

 DBGPRINT("DBG: GetURL: [%s|%s] base-type:%d anchor-type:%d\n",sBaseHRef.Str(),strURI,pathTypeBase,pathTypeAnchor);

 switch ( pathTypeBase ) {
 case gURI::e_Absolute:
 case gURI::e_Relative:
 case gURI::e_RelativeQualified:
     sOut = sBaseHRef;
     break;
 case gURI::e_NoType:
 default:
     sOut.SetEmpty();
     break;
 }
 if ( pathTypeAnchor==gURI::e_Absolute ) {
     sOut.Set( strURI );
 }
 else {
     sOut.Add( aURI.Str() );
 }
 return sOut.Str();
}

bool gHSeq::SetBaseHRef (gString& aBaseHRef)
{
 sBaseHRef = aBaseHRef;
 if ( sBaseHRef[sBaseHRef.Length()]!='/' ) sBaseHRef.Add( '/' );
 baseURI.SetString( sBaseHRef.Str() );
 return baseURI.GetPathType()!=gURI::e_NoType;
}

int gHSeq::Build (gHList& lH, eHState state)
{
 int error;
 unsigned n = lH.N();

 delete[] pTagCoords;
 pTagCoords = new gTagCoord[ n+1 ];
 ASSERTION(pTagCoords!=nil,"pTagCoords!=nil");

 error = thisCheck( lH, state, 1, n );
 DBGPRINT_WEB("DBG: gHSeq::Check: error=%d\n",error);
 if ( error!=0 ) return error;

#ifdef DEBUG
 ///lH.Show( true ); printf("DBG: <EOX>\n");
 for (t_int32 kCoord=1; kCoord<=nCoords; kCoord++) {
     int yLine = pTagCoords[kCoord].GetY();
     printf("%u/%u: {%d,%d},y=%d [%s]\n",kCoord,nCoords,yLine,pTagCoords[kCoord].GetZ(),pTagCoords[kCoord].depth,lH.GetCouple(yLine)->GetStr());
 }
#endif //DEBUG...

 delete[] pTagTree;
 pTagTree = new gTagTree[ nCoords+1 ];  // Maximized
 ASSERTION(pTagTree!=nil,"pTagTree!=nil");
 nTagTree = 0;

 error = thisBuild( lH );
 DBGPRINT_WEB("DBG: gHSeq::Build: error=%d\n",error);
 ASSERTION(error==0,"error==0");

 error = thisConsolidate( hTree );
 DBGPRINT_WEB("DBG: gHSeq::Consolidate: error=%d\n",error);
 ASSERTION(error==0,"error==0");

 return 0;
}

void gHSeq::ShowPart (gHList& lH, eHState state, gHtmlOpt& htmlOpt)
{
 unsigned i, stN;
 gHParsed pHAux;
 stN = lH.N();
 if ( stN>0 ) {
     for (i=1; i<=stN; i++)
	 printf("%s%s\n",htmlOpt.outFmt.GetBeginLineStr( state, i ),lH.Str( i ));
 }
}

int gHSeq::thisCheck (gHList& lH, eHState state, unsigned sttLine, unsigned endLine)
{
 unsigned i;
 unsigned nParsed;
 t_int16 id;
 t_int32 idxCoord;
 bool isText;
 bool inRefEnd, inCannotEnd, inOptEnd;
 gHtmlCouple* pObjC;
 gHParsed hParsed;


 if ( state==e_HS_Sp_FakeBody ) {
     pObjC = new gHtmlCouple( 0, "BODY", nil );
     ASSERTION(pObjC!=nil,"pObjC!=nil");
     delete lH.coupleFakeBody;
     lH.coupleFakeBody = pObjC;
     nCoords++;
     pTagCoords[ nCoords ].SetTagId( XH_IDTAG_BODY );
     pTagCoords[ nCoords ].SetY( 0 ); //tag start (line)
     hParsed.PushTag( *pObjC );
     pTagCoords[ nCoords ].depth = hParsed.Depth();
 }

 // Build-up pTagCoords

 for (i=sttLine; i<=endLine; i++) {
     pObjC = lH.GetCouple( i );
     id = pObjC->idTag;
     isText = pObjC->IsText();
     DBGPRINT("DBG: %u/%u: idTag=%d/synError=%d [%s] OK?%c\n",i,endLine,id,pObjC->synError,pObjC->GetStr(),ISyORn(pObjC->IsOk()));
     if ( isText || pObjC->synError<0 ) continue;
     inCannotEnd = pObjC->pElem->CannotEndTag();
     inOptEnd = pObjC->pElem->MayEndTag();
     inRefEnd = pObjC->IsTagEnd();

     //bool isAnchorStart = pObjC->IsAnchor()==true && inRefEnd==false; printf("DBG: CHK: %s [%d]%c%s%s\n",pObjC->GetStr(),id,isText?'.':inCannotEnd?':':inRefEnd?'/':'\\',isAnchorStart?"ANCHOR":"\0",inOptEnd?" MayNotEnd":"\0");
     //if ( isAnchorStart ) printf("DBG: CHK: HREF=[%s] URL=[%s]\n",pObjC->GetHRef(),GetURL( pObjC->GetHRef() ));
     // Note: GetURL( ... ) returns the full link reference (if specified by HREF, otherwise, returns nil)
     // .
     //Ahdoc tip: to find <Hn> (e.g. <H1> and </H1> pair), we would apply: id>=XH_IDTAG_H1 && id<=XH_IDTAG_HL ...

     if ( inCannotEnd || inOptEnd ) continue;

     // Check if hard-coded suppression works
     if ( id==XH_IDTAG_TABLEx || id==XH_IDTAG_FONTx ) continue; // -temp

     if ( inRefEnd ) {
	 hParsed.PopTag( false );
	 for (idxCoord=nCoords; idxCoord>0; idxCoord--)
	     if ( id==pTagCoords[idxCoord].GetTagId() && pTagCoords[idxCoord].GetZ()==0 ) break;
	 ASSERTION(idxCoord>0,"idxCoord>0");
	 pTagCoords[ idxCoord ].SetZ( i ); //end tag (line)
     }
     else {
	 nCoords++;
	 pTagCoords[ nCoords ].SetTagId( id );
	 pTagCoords[ nCoords ].SetY( i ); //tag start (line)
	 hParsed.PushTag( *pObjC );
	 pTagCoords[ nCoords ].depth = hParsed.Depth();
     }
 }

#ifdef DEBUG
 for (idxCoord=1; idxCoord<=nCoords; idxCoord++) {
     if ( pTagCoords[idxCoord].IsOk()==false && pTagCoords[idxCoord].GetTagId()!=XH_IDTAG_BODY )
	 printf("DBG: COORD(%d): tagId=%d (START=%d/END=%d) OK?%c\n",(int)idxCoord,pTagCoords[idxCoord].GetTagId(),pTagCoords[idxCoord].GetY(),pTagCoords[idxCoord].GetZ(),ISyORn(pTagCoords[idxCoord].IsOk()));
 }
#endif //DEBUG...

 for (idxCoord=1, i=0; idxCoord<=nCoords; idxCoord++) i += pTagCoords[idxCoord].IsOk()==false;

 DBGPRINT_WEB3("DBG: thisCheck: i=%u(1 is o.k., >1 error), nParsed=%u\n",i,hParsed.N());
 if ( i>1 ) return 1; // E.g. <BODY> is included in lH, but not </BODY>, so at least one unterminated tag allowed

 idxCoord = 1;
 nParsed = hParsed.N();
 if ( i>0 ) {
     DBGPRINT_WEB3("DBG: Body idxCoord=%ld, y(next)=%d\n",(long)idxCoord,pTagCoords[idxCoord].GetY());
     if ( pTagCoords[idxCoord].IsOk()==true ) return 2; //First tag should be unterminated (e.g. <BODY>)
     iCoordStt = ++idxCoord;
     ASSERTION(nParsed>0,"nParsed>0");
     nParsed--; // Discount e.g. <BODY>
 }

 if ( nParsed>0 ) return 4;
 return 0;
}

int gHSeq::thisBuild (gHList& lH)
{
 // Return always 0
 int y, z, deltaLines, keepZ;
 int hLine, inY;
 int blockY;
 int thisDepth;
 int errAppend;
 int idxTagTree;
 t_int16 id;
 t_int32 idxCoord = iCoordStt;
 t_int32 kCoord, mCoord;
 t_int32 inCoord;
 bool doSkip;
 bool isRemembered;
 gHtmlCouple* pObjC;

 DBGPRINT_WEB1("DBG: thisBuild: y(iCoordStt=%ld/%ld)=%d\n",(long)iCoordStt,(long)nCoords,pTagCoords[idxCoord].GetY());

 // Append text stuff before first tag
 for (hLine=1; hLine<pTagCoords[idxCoord].GetY(); hLine++) {
     pObjC = lH.GetCouple( (unsigned)hLine );
     if ( pObjC->idTag>=0 && iCoordStt>1 ) continue;  // Skip first tag, redundant for the blocks
     DBGPRINT_WEB2("DBG: TXT-prepend: %s\n",pObjC->GetStr());
     thisAppendNormal( pObjC );
 }

 // Start block join
 for (z=-1; idxCoord>0 && idxCoord<=nCoords; ) {
     keepZ = z;
     y = pTagCoords[ idxCoord ].GetY();
     z = pTagCoords[ idxCoord ].GetZ();
     thisDepth = pTagCoords[ idxCoord ].depth;
     ASSERTION(thisDepth>1,"thisDepth>1");
     deltaLines = z - y;  // e.g. end-line 12 and start-line 10 gives 2, because end-tag on 12 is skipped
     ASSERTION(deltaLines>0 && z>0,"deltaLines>0");

     DBGPRINT_WEB1("\nDBG: idxCoord=%d/%d,thisDepth=%d: [%s]\n",idxCoord,nCoords,thisDepth,lH.GetCouple( y )->GetStr());
     // Add lines before 'y'
     for (hLine=keepZ+1; hLine<y && keepZ>0; hLine++) {
	 pObjC = lH.GetCouple( (unsigned)hLine );
	 if ( pObjC->IsTagEnd() ) continue;
	 DBGPRINT_WEB2("DBG: ADDTXT: %s\n",pObjC->GetStr());
	 thisAppendNormal( pObjC );
     }
     //
     // Before adding the current block, seek if any sub-blocks exist (and store the line: blockY)
     for (kCoord=idxCoord+1, blockY=-1, inCoord=0; kCoord<=nCoords; kCoord++) {
	 inY = pTagCoords[ kCoord ].GetY();
	 if ( inY<z && blockY<=-1 && pTagCoords[ kCoord ].opId==0 ) {
	     blockY = inY;
	     inCoord = kCoord;
	     pTagCoords[ kCoord ].opId = (t_int16)inCoord;
	 }
     }
     DBGPRINT_WEB2("DBG: blockY=%d [%s]\n",blockY,blockY<=-1?"-":lH.GetCouple(blockY)->GetStr());

     if ( blockY<=-1 ) {
	 // No sub-block
	 gHTree* thisBlock = NewTree();
	 gHTree* subBlock = NewTree();
	 gHTree* whichBlock;

	 // Check if block is already remembered: if yes, then append this couple to it, not to subBlock
	 whichBlock = thisFindRememberedBlock( idxCoord, y, idxTagTree );
	 if ( (isRemembered = idxTagTree>0)==true ) {
	     // Reset (like deleting...) this remembered block
	     pTagTree[ idxTagTree ].Reset();
	 }
	 else {
	     whichBlock = subBlock;
	 }

	 for (hLine=y; hLine<z; hLine++) {
	     pObjC = lH.GetCouple( hLine );
	     id = pObjC->idTag;
	     if ( thisLineSubBlock( hLine, idxCoord+1, doSkip ) || doSkip ) {
		 DBGPRINT_WEB2("DBG: SG-subBlock skip: %s\n",pObjC->GetStr());
		 continue;
	     }
	     ASSERTION(whichBlock!=nil,"whichBlock!=nil");  // Academic assert
	     if ( id==XH_IDTAG_ANCHOR && pObjC->IsTagEnd()==false ) {
		 gHTree* inAnchor = NewTree();
		 gHtmlCouple* pObjX = nil;
		 for (int kLine=hLine; kLine<z; kLine++) {
		     pObjX = lH.GetCouple( kLine );
		     if ( pObjX->IsTagEnd()==true ) {
			 if ( pObjX->idTag==XH_IDTAG_ANCHOR ) break;
		     }
		     else {
			 inAnchor->AppendCouplePtr( pObjX );
		     }
		 }
		 ASSERTION(pObjX!=nil,"pObjX!=nil");
		 whichBlock->AppendTreePtr( inAnchor );
		 DBGPRINT_WEB1("DBG: SA-subBlock add: [%s|%s|...]\n",pObjC->GetStr(),pObjX->GetStr());
	     }
	     else {
		 if ( pObjC->IsTagEnd()==false ) {
		     errAppend = whichBlock->AppendCouplePtr( pObjC );
		     DBGPRINT_WEB1("DBG: SG-subBlock add%s: [%s]%s\n",errAppend==0?"\0":"{SKIP}",pObjC->GetStr(),isRemembered?" {REMEMBERED}":"\0");
		 }
	     }
	 }
	 if ( isRemembered ) {
	     // Unuseful created blocks
	     delete thisBlock;
	     delete subBlock;
	 }
	 else {
	     thisBlock->AppendTreePtr( subBlock );
	     thisAppendTree( thisBlock );
	 }
	 idxCoord++; continue;
     }

     // At least one sub-block
     gHTree* inBlock = NewTree();
     gHTree* subBlock = NewTree();
     ASSERTION(inBlock!=nil,"inBlock!=nil");
     ASSERTION(subBlock!=nil,"subBlock!=nil");
     for (hLine=y+1; hLine<blockY; hLine++) {
	 // Non-tag before block added to 'inBlock'
	 pObjC = lH.GetCouple( hLine );
	 if ( pObjC->IsTagEnd() ) continue;
	 errAppend = inBlock->AppendCouplePtr( pObjC );
	 DBGPRINT_WEB1("DBG: inBlock add%s: [%s]\n",errAppend==0?"\0":"{SKIP}",pObjC->GetStr());
     }
     ASSERTION(hLine==blockY,"hLine==blockY");
     gHTree* thisBlock = NewTree();
     ASSERTION(thisBlock!=nil,"thisBlock!=nil");
     pObjC = lH.GetCouple( y );
     errAppend = thisBlock->AppendCouplePtr( pObjC );
     DBGPRINT_WEB1("DBG: inBlock-thisBlock add%s: [%s]\n",errAppend==0?"\0":"{SKIP}",pObjC->GetStr());
     thisBlock->AppendTreePtr( inBlock );
     ;
     if ( thisDepth+1==pTagCoords[ inCoord ].depth ) {
	 for (hLine=blockY; hLine<pTagCoords[ inCoord ].GetZ(); hLine++) {
	     pObjC = lH.GetCouple( hLine );
	     if ( thisLineSubBlockCoord( hLine, inCoord+1, mCoord, doSkip )!=0 ) {
		 DBGPRINT_WEB1("DBG: IN-subBlock remember: mCoord(%d, line=%d): %s\n",mCoord,hLine,pObjC->GetStr());
		 gHTree* innerBlock = NewTree( mCoord, hLine, pObjC->GetStr(), true );
		 subBlock->AppendTreePtr( innerBlock );
	     }
	     if ( doSkip ) {
		 DBGPRINT_WEB1("DBG: IN-subBlock rem{--SKIP--}: %s\n",pObjC->GetStr());
		 continue;
	     }
	     errAppend = subBlock->AppendCouplePtr( pObjC );
	     DBGPRINT_WEB1("DBG: IN-subBlock add%s: [%s]\n",errAppend==0?"\0":"{SKIP}",pObjC->GetStr());
	 }
     }
     thisBlock->AppendTreePtr( subBlock );
     thisAppendTree( thisBlock );
     z = hLine;  // To update next-loop keepZ
 }//end FOR idxCoord

 idxCoord--;
 if ( idxCoord<=iCoordStt ) return 0;

 // Add trailing text
 for (hLine=pTagCoords[idxCoord].GetZ()+1, inY=lH.N(); hLine<=inY; hLine++) {
     pObjC = lH.GetCouple( (unsigned)hLine );
     if ( pObjC->IsText() ) thisAppendNormal( pObjC );
 }

 // end 'thisBuild'
 return 0;
}

int gHSeq::thisConsolidate (gHTree& hT)
{
 ;
 return 0;
}

int gHSeq::thisLineSubBlock (int hLine, t_int32 startCoord, bool& doSkip)
{
 t_int32 fCoord;
 return thisLineSubBlockCoord( hLine, startCoord, fCoord, doSkip );
}

int gHSeq::thisLineSubBlockCoord (int hLine, t_int32 startCoord, t_int32& fCoord, bool& doSkip)
{
 int y, z;
 t_int32 kCoord;

 // Returns 1 only if 'hLine' matches exactly one 'Y' coordinate (of 'pTagCoords')
 for (kCoord=startCoord, doSkip=true; kCoord<=nCoords; kCoord++) {
     fCoord = kCoord;
     if ( hLine==(y = pTagCoords[ kCoord ].GetY()) ) return 1;
     z = pTagCoords[ kCoord ].GetZ();
     if ( hLine>y && hLine<=z ) return 0;
 }
 doSkip = false;
 fCoord = -1;
 return 0;
}

gHTree* gHSeq::thisFindRememberedBlock (t_int32 mCoord, int hLine, int& idxTagTree)
{
 // Finds if any remembered block matches the coordinate index 'mCoord'.

 int k;

 idxTagTree = 0;
 for (k=1; k<=nTagTree; k++) {
     if ( pTagTree[k].mCoord==mCoord &&
	  pTagTree[k].GetY()==hLine ) {
	 idxTagTree = k;
	 ASSERTION(pTagTree[k].IsOk(),"pTagTree[k].IsOk()");
	 return pTagTree[k].myTree;
     }
 }
 // ...not found
 return nil;
}

int gHSeq::thisAppendNormal (gHtmlCouple* pCouple)
{
 if ( pCouple==nil ) return -1;
 hTree.AppendCouplePtr( pCouple );
 return 0;
}

int gHSeq::thisAppendTree (gHTree* pTree)
{
 ASSERTION(pTree!=nil,"pTree!=nil");
 return hTree.AppendTreePtr( pTree );
}

gHTree* gHSeq::NewTree (t_int32 mCoord, int hLine, char* descStr, bool doRegister)
{
 gHTree* newTree = new gHTree;
 ASSERTION(newTree!=nil,"newTree!=nil");
 if ( doRegister==false )
     return newTree;
 nTagTree++;
 if ( descStr!=nil ) pTagTree[ nTagTree ].sDesc.Set( descStr );
 pTagTree[ nTagTree ].SetY( hLine );
 pTagTree[ nTagTree ].mCoord = mCoord;
 return pTagTree[ nTagTree ].myTree = newTree;
}
////////////////////////////////////////////////////////////

