#ifndef gHTML_SEQ_X_H
#define gHTML_SEQ_X_H

#include "gHtmlOpt.h"
#include "gHtmlParser.h"
#include "ghttp.h"

class gHTree;
////////////////////////////////////////////////////////////
class gTagTree : public gTagCoord {
public:
    gTagTree (char* descStr=nil) ;
    virtual ~gTagTree () ;

    gString sDesc;
    t_int32 mCoord;
    gHTree* myTree;  // Never allocated here

    virtual bool IsOk () {
	return myTree!=nil && GetY()>0;
    }

    virtual char* Str () ;

    virtual void Reset () ;

private:
    // Operators,empty
    gTagTree (gTagTree& ) ; //empty
    gTagTree& operator= (gTagTree& ) ; //empty
};
////////////////////////////////////////////////////////////
class gHNode : public gControl {
public:
    gHNode () ;
    virtual ~gHNode () ;

    // Public data-members
    gHNode* nextNode;
    gHTree* tSub;

    // Get methods
    virtual bool IsTag () {
	return pCouple!=nil && pCouple->IsText()==false;
    }

    virtual gHtmlCouple* GetCouple () ;
    virtual gHtmlCouple* GetCouplePtr () {
	return pCouple;
    }

    // Set methods
    virtual bool SetCouplePtr (gHtmlCouple* ptrCouple) ;

protected:
    gHtmlCouple* pCouple; //Never allocated

private:
    // Operators,empty
    gHNode (gHNode& ) ; //empty
    gHNode& operator= (gHNode& ) ; //empty
};
////////////////////////////////////////////////////////////
class gHTree : public gList {
public:
    gHTree () ;
    virtual ~gHTree () ;

    // Get methods
    virtual bool IsEmpty () {
	return pStart==nil;
    }
    virtual gHNode* StartNode () {
	return pStart;
    }
    virtual gHNode* GetLastNode () ;

    // Set methods
    virtual void Reset () ;
    virtual int AppendCouplePtr (gHtmlCouple* ptrCouple) ;
    virtual int AppendTreePtr (gHTree* pTree) ;

    // Show methods
    virtual void Show (bool doShowAll=true) ;
    virtual void ShowTree (bool doShowAll=true, int level=0) ;

protected:
    gHNode* pStart;
    gHNode* pEnd;

    int thisAppendNode (gHNode* newNode) ;
    int thisShowNode (gHNode* pNode, bool doShowAll, int level) ;

private:
    // Operators,empty
    gHTree (gHTree& ) ; //empty
    gHTree& operator= (gHTree& ) ; //empty
};
////////////////////////////////////////////////////////////
class gHSeq : public gControl {
public:
    gHSeq (FILE* afRepErr) ;
    virtual ~gHSeq () ;

    // Public data-members
    FILE* fRepErr;
    gHTree hTree;

    // Get methods
    virtual char* GetURL (char* strURI) ;

    // Set methods
    virtual bool SetBaseHRef (gString& aBaseHRef) ;

    // Specific methods
    virtual int Build (gHList& lH, eHState state) ;

    // Show methods
    void ShowPart (gHList& lH, eHState state, gHtmlOpt& htmlOpt) ;

protected:
    gString sBaseHRef;
    gString sOut;
    gURI baseURI;
    t_int32 nCoords, iCoordStt;
    gTagCoord* pTagCoords;  // Allocated at 'Build'

    int thisCheck (gHList& lH, eHState state, unsigned sttLine, unsigned endLine) ;
    int thisBuild (gHList& lH) ;
    int thisConsolidate (gHTree& hT) ;

    int thisLineSubBlock (int hLine, t_int32 mCoord, bool& doSkip) ;
    int thisLineSubBlockCoord (int hLine, t_int32 startCoord, t_int32& fCoord, bool& doSkip) ;

    gHTree* thisFindRememberedBlock (t_int32 mCoord, int hLine, int& idxTagTree) ;

    int thisAppendNormal (gHtmlCouple* pCouple) ;
    int thisAppendTree (gHTree* pTree) ;

private:
    int nTagTree;
    gTagTree* pTagTree;  // Allocated at 'Build' (remembered trees)
    gHTree* NewTree (t_int32 mCoord=-1, int hLine=0, char* descStr=nil, bool doRegister=false) ;

    // Operators,empty
    gHSeq (gHSeq& ) ; //empty
    gHSeq& operator= (gHSeq& ) ; //empty
};
////////////////////////////////////////////////////////////
#endif //gHTML_SEQ_X_H

