// gdNetStrings.cpp -- Version 1.0

#include <string.h>
#include "gdNetStrings.h"
#include "gstringext.h"
////////////////////////////////////////////////////////////
// Static members
// ---------------------------------------------------------
unsigned gHtmlString::nTblSymUsu=0;
t_uint32 gHtmlString::vTblSymUsuMin=0;
unsigned gHtmlString::nTblSymIsoLatin1=0;
t_uint32 gHtmlString::vTblSymIsoL1Min=0;
t_uint32 gHtmlString::vTblSymIsoL1Max=0;

sHtmlEntSymbol gHtmlString::tblSymUsu[191-160+10]={
	{"nbsp",		160,	'U', "no-break space"},
	{"iexcl",		161,	'@', "inverted exclamation mark"},
	{"cent",		162,	'@', "cent sign"},
	{"pound",		163,	'U', "pound sterling sign"},
	{"curren",		164,	'@', "general currency sign"},
	{"yen" ,		165,	'@', "yen sign"},
	{"brvbar",		166,	'@', "broken (vertical) bar"},
	{"sect",		167,	'@', "section sign"},
	{"uml" ,		168,	'@', "umlaut (dieresis)"},
	{"copy",		169,	'U', "copyright sign"},
	{"ordf",		170,	'@', "ordinal indicator, feminine"},
	{"laquo",		171,	'@', "angle quotation mark, left"},
	{"not" ,		172,	'@', "not sign"},
	{"shy" ,		173,	'@', "soft hyphen"},
	{"reg" ,		174,	'U', "registered sign"},
	{"macr",		175,	'@', "macron"},
	{"deg" ,		176,	'@', "degree sign"},
	{"plusmn",		177,	'@', "plus-or-minus sign"},
	{"sup2",		178,	'n', "superscript two"},
	{"sup3",		179,	'n', "superscript three"},
	{"acute",		180,	'U', "acute accent"},
	{"micro",		181,	'@', "micro sign"},
	{"para",		182,	'@', "pilcrow (paragraph sign)"},
	{"middot",		183,	'@', "middle dot"},
	{"cedil",		184,	'@', "cedilla"},
	{"sup1",		185,	'n', "superscript one"},
	{"ordm",		186,	'@', "ordinal indicator, masculine"},
	{"raquo",		187,	'@', "angle quotation mark, right"},
	{"frac14",		188,	'n', "fraction one-quarter"},
	{"frac12",		189,	'n', "fraction one-half"},
	{"frac34",		190,	'n', "fraction three-quarters"},
	{"iquest",		191,	'@', "inverted question mark"},
	{nil, 0, '\0', nil}};

sHtmlEntSymbol gHtmlString::tblSymIsoLatin1[255-198+30]={
    	{"AElig",	198,	'C', "AE diphthong (ligature)"},
	{"Aacute",	193,	'C', "A, acute accent"},
	{"Acirc",	194,	'C', "A, circumflex accent"},
	{"Agrave",	192,	'C', "A, grave accent"},
	{"Aring",	197,	'C', "A, ring"},
	{"Atilde",	195,	'C', "A, tilde"},
	{"Auml",	196,	'C', "A, dieresis or umlaut mark"},
	{"Ccedil",	199,	'C', "C, cedilla"},
	{"ETH" ,	208,	'C', "Eth, Icelandic"},
	{"Eacute",	201,	'C', "E, acute accent"},
	{"Ecirc",	202,	'C', "E, circumflex accent"},
	{"Egrave",	200,	'C', "E, grave accent"},
	{"Euml",	203,	'C', "E, dieresis or umlaut mark"},
	{"Iacute",	205,	'C', "I, acute accent"},
	{"Icirc",	206,	'C', "I, circumflex accent"},
	{"Igrave",	204,	'C', "I, grave accent"},
	{"Iuml",	207,	'C', "I, dieresis or umlaut mark"},
	{"Ntilde",	209,	'C', "N, tilde"},
	{"Oacute",	211,	'C', "O, acute accent"},
	{"Ocirc",	212,	'C', "O, circumflex accent"},
	{"Ograve",	210,	'C', "O, grave accent"},
	{"Oslash",	216,	'C', "O, slash"},
	{"Otilde",	213,	'C', "O, tilde"},
	{"Ouml",	214,	'C', "O, dieresis or umlaut mark"},
	{"THORN",	222,	'C', "THORN, Icelandic"},
	{"Uacute",	218,	'C', "U, acute accent"},
	{"Ucirc",	219,	'C', "U, circumflex accent"},
	{"Ugrave",	217,	'C', "U, grave accent"},
	{"Uuml",	220,	'C', "U, dieresis or umlaut mark"},
	{"Yacute",	221,	'C', "Y, acute accent"},
	{"aacute",	225,	's', "a, acute accent"},
	{"acirc",	226,	's', "a, circumflex accent"},
	{"aelig",	230,	's', "ae diphthong (ligature)"},
	{"agrave",	224,	's', "a, grave accent"},
	{"aring",	229,	's', "a, ring"},
	{"atilde",	227,	's', "a, tilde"},
	{"auml",	228,	's', "a, dieresis or umlaut mark"},
	{"ccedil",	231,	's', "c, cedilla"},
	{"eacute",	233,	's', "e, acute accent"},
	{"ecirc",	234,	's', "e, circumflex accent"},
	{"egrave",	232,	's', "e, grave accent"},
	{"eth" ,	240,	's', "eth, Icelandic"},
	{"euml",	235,	's', "e, dieresis or umlaut mark"},
	{"iacute",	237,	's', "i, acute accent"},
	{"icirc",	238,	's', "i, circumflex accent"},
	{"igrave",	236,	's', "i, grave accent"},
	{"iuml",	239,	's', "i, dieresis or umlaut mark"},
	{"ntilde",	241,	's', "n, tilde"},
	{"oacute",	243,	's', "o, acute accent"},
	{"ocirc",	244,	's', "o, circumflex accent"},
	{"ograve",	242,	's', "o, grave accent"},
	{"oslash",	248,	's', "o, slash"},
	{"otilde",	245,	's', "o, tilde"},
	{"ouml",	246,	's', "o, dieresis or umlaut mark"},
	{"szlig",	223,	's', "@sharp s, German (sz ligature)"},
	{"thorn",	254,	's', "thorn, Icelandic"},
	{"uacute",	250,	's', "u, acute accent"},
	{"ucirc",	251,	's', "u, circumflex accent"},
	{"ugrave",	249,	's', "u, grave accent"},
	{"uuml",	252,	's', "u, dieresis or umlaut mark"},
	{"yacute",	253,	's', "y, acute"},
	{"yuml",	255,	's', "y, dieresis or umlaut mark"},
	{nil, 0, '\0', nil}};
////////////////////////////////////////////////////////////
gHtmlString::gHtmlString (char* s, bool aIgnoreAmp)
    : lastOpError( 0 ),
      doIgnoreAmp( aIgnoreAmp )
{
 thisFillUpTables();
 ConvertToHString( s );
}

gHtmlString::~gHtmlString ()
{
}

char* gHtmlString::AsciiToString (t_uchar v)
{
 switch ( v ) {
 case '\n':
     return "<BR>\n";
 case '<':
     return thisStrSymbolAmp("lt");
 case '>':
     return thisStrSymbolAmp("gt");
 case '&':
     return thisStrSymbolAmp("amp");
 case '"':
     return thisStrSymbolAmp("quot");
 case '\t':
     return nil;
 case 127:
     lastOpError = 32;
     return nil;
 default:
     break;
 }
 if ( v<' ' ) return nil;
 if ( v<127 ) {
     sEntStr.SetEmpty(); sEntStr.Add( v );
     return sEntStr.Str();
 }
 return thisSymbolString( (t_uint32)v );
}

int gHtmlString::ConvertToHString (char* s)
{
 // E.g.: "CA~O"(C,A-tilde,O) into "C&Atilde;O"
 // (this word: dog in portuguese)
 // If doIgnoreAmp=false (default), then
 // upon receiving a string like "C&Atilde;O",
 // it will be expanded exactly as is.

 lastOpError = 0;
 sOriStr.SetEmpty();
 Delete();  // Completely deletes the list
 if ( s==nil ) return 0;

 sOriStr.Set( s );

 if ( doIgnoreAmp )
     return thisConvertToHStringIgnoreAmp( s );

 gString sResult;
 lastOpError = ConvertAmpToAscii( s, sResult );
 DBGPRINT_MIN("DBG: gHtmlString:[%s|%s] OpError=%d\n",s,sResult.Str(),lastOpError);
 if ( lastOpError!=0 ) sResult.Set( s );
 // Check: not kept lastOpError
 return thisConvertToHStringIgnoreAmp( sResult.Str() );
}

int gHtmlString::ConvertAmpToAscii (char* s, gString& sResult)
{
 int error, resError=0;
 unsigned i, pos, len;
 t_uchar uChr;

 ASSERTION(s!=nil,"s!=nil");
 sResult.SetEmpty();

 gString sIn( s );
 for (i=1, len=sIn.Length(); i<=len; i++) {
     uChr = sIn[i];
     if ( uChr=='&' ) {
	 pos = gStrControl::Self().Find( s+i, ";" );
	 if ( pos==0 ) return 64;  // &XYZ, but no ';'
	 gString sTemp;
	 sTemp.CopyFromTo( sIn, i, i+pos );
	 i += pos;
	 error = ConvertHToAscii( sTemp.Str(), uChr );
	 ASSERTION(error>=0,"error>=0");
	 if ( error!=0 ) {
	     resError = 65;  // &XYZ; but XYZ not known!
	     continue;
	 }
     }
     sResult.Add( uChr );
 }
 return resError;
}

int gHtmlString::ConvertHToAscii (char* sAmp, t_uchar& cRes)
{
 // Return -1 if "&XYZ;" format is not present;
 // 0 if all ok; or other >0 error when not found "XYZ"
 unsigned len;
 ASSERTION(sAmp!=nil,"sAmp!=nil");
 cRes = 0;
 if ( sAmp[0]!='&' ) return -1;
 gString s( sAmp+1 );
 if ( s[len = s.Length()]!=';' ) return -1;
 if ( len<=2 ) return 1;
 gString sIn;
 sIn.CopyFromTo( s, 1, len-1 );
 short tblIdx;
 unsigned idx;
 return thisConvertHToAscii( sIn, tblIdx, idx, cRes )!=0;
}

int gHtmlString::thisConvertToHStringIgnoreAmp (char* s)
{
 char* str;
 t_uchar v;
 int error=0, resError=0;

 for ( ; (v = (t_uchar)s[0])!=0; s++) {
     str = AsciiToString( v );
     error = lastOpError!=0 || str==nil;
     if ( error==0 )
	 Add( str );
     else
	 resError = error;
 }
 return resError;
}

char* gHtmlString::thisSymbolString (t_uint32 val)
{
 unsigned idx;
 if ( val<vTblSymUsuMin && val<vTblSymIsoL1Min ) {
     lastOpError = 8;  // No usual symbol, nor within ISO chars
     return nil;
 }
 if ( val>vTblSymIsoL1Max ) {
     lastOpError = 9;  // No usual symbol, nor within ISO chars, ASCII too high
     return nil;
 }
 if ( val>=vTblSymIsoL1Min ) {
     return thisStrSymbolAmp( thisFindSymbolISO( 1/*As in 8859-1*/, val, nTblSymIsoLatin1, idx ) );
 }
 if ( val>=vTblSymUsuMin && val<vTblSymUsuMin+(t_uint32)nTblSymUsu ) {
     val -= vTblSymUsuMin;
     return thisStrSymbolAmp( tblSymUsu[val].sName );
 }
 return nil;
}

char* gHtmlString::thisFindSymbolISO (short tblIdx,
				      t_uint32 val,
				      unsigned nEntries,
				      unsigned& idx)
{
 t_uint32 vAscii;
 for (idx=0; idx<nEntries; idx++) {
     // switch ( tblIdx ) -<- optimized, removed
     // sHtmlEntSymbol* pSym = &tblSymIsoLatin1[idx] ...
     vAscii = tblSymIsoLatin1[idx].vAscii;
     if ( vAscii==val ) return tblSymIsoLatin1[idx].sName;
 }
 idx = MAX_UINT16_U;  // Or zero
 return nil;
}

int gHtmlString::thisConvertHToAscii (gString& s,
				      short& tblIdx,
				      unsigned& idx,
				      t_uchar& cRes)
{
 // Input 's' is not "&XYZ;" but "XYZ" only; return 0 iff ok
 // Return 1 if out-of-bounds (ASCII>=256), 2 on other error
 char* str = s.Str();
 t_uint32 vAscii;

 cRes = 0;

 // Check first whether is a regular "amp", "lt", ...
 if ( strcmp(str,"amp")==0 ) {
     cRes = '&';
     return 0;
 }
 if ( strcmp(str,"lt")==0 ) {
     cRes = '<';
     return 0;
 }
 if ( strcmp(str,"gt")==0 ) {
     cRes = '>';
     return 0;
 }
 if ( strcmp(str,"quot")==0 ) {
     cRes = '"';
     return 0;
 }
 // Maybe in TblSymUsu or in Latin1
 for (idx=0, tblIdx=0; idx<nTblSymUsu; idx++) {
     if ( strcmp(str,tblSymUsu[idx].sName)==0 ) {
	 cRes = (t_uchar)(vAscii = tblSymUsu[idx].vAscii);
	 return vAscii>=256;
     }
 }
 for (idx=0, tblIdx=1; idx<nTblSymIsoLatin1; idx++) {
     if ( strcmp(str,tblSymIsoLatin1[idx].sName)==0 ) {
	 cRes = (t_uchar)(vAscii = tblSymIsoLatin1[idx].vAscii);
	 return vAscii>=256;
     }
 }
 tblIdx = -1;
 return 2;
}

char* gHtmlString::thisStrSymbolAmp (char* s)
{
 sEntStr.SetEmpty();
 if ( s==nil ) {
     lastOpError = 16;
     return nil;
 }
 sEntStr.Add( '&' );
 sEntStr.Add( s );
 sEntStr.Add( ';' );
 return sEntStr.Str();
}

int gHtmlString::thisFillUpTables ()
{
 unsigned idx;
 t_uint32 v, vMin=(t_uint32)MAX_UINT16_U, vMax=0;

 if ( nTblSymUsu>0 ) return 0; // Already calculate

 // Usual symbols
 for (idx=0; (v = tblSymUsu[idx].vAscii)!=0; idx++) {
     if ( idx==0 ) vTblSymUsuMin = v;
     nTblSymUsu++;
 }
 for (idx=0; (v = tblSymIsoLatin1[idx].vAscii)!=0; idx++) {
     nTblSymIsoLatin1++;
     if ( v<vMin ) vMin = v;
     if ( v>vMax ) vMax = v;
 }
 vTblSymIsoL1Min = vMin;
 vTblSymIsoL1Max = vMax;
 return 0;
}
////////////////////////////////////////////////////////////

