#ifndef X_GDNETSTRINGS_H
#define X_GDNETSTRINGS_H

#include "ghttp.h"
////////////////////////////////////////////////////////////
struct sHtmlEntSymbol {
    char* sName;
    t_uint32 vAscii;
    char symRef;  // C:capital, S:small, n:numeric, U:usual-symbol
    char* sDesc;
};
////////////////////////////////////////////////////////////
// CLASS gHtmlString
////////////////////////////////////////////////////////////
class gHtmlString : public gString {
public:
    gHtmlString (char* s=nil, bool aIgnoreAmp=false) ;
    virtual ~gHtmlString () ;

    // Public data-members
    int lastOpError;
    bool doIgnoreAmp;

    // Get methods
    virtual bool IsOk () {
	return lastOpError==0;
    }
    virtual char* AsciiToString (t_uchar v) ;

    // Special methods
    virtual int ConvertToHString (char* s) ;
    virtual int ConvertAmpToAscii (char* s, gString& sResult) ;
    virtual int ConvertHToAscii (char* sAmp, t_uchar& cRes) ;

protected:
    static unsigned nTblSymUsu;
    static t_uint32 vTblSymUsuMin;
    static unsigned nTblSymIsoLatin1;
    static t_uint32 vTblSymIsoL1Min, vTblSymIsoL1Max;
    static sHtmlEntSymbol tblSymUsu[191-160+10/* +1 would be enough*/];
    static sHtmlEntSymbol tblSymIsoLatin1[255-198+30];

    int thisConvertToHStringIgnoreAmp (char* s) ;

    char* thisSymbolString (t_uint32 val) ;

    char* thisFindSymbolISO (short tblIdx,
			     t_uint32 val,
			     unsigned nEntries,
			     unsigned& idx) ;

    int thisConvertHToAscii (gString& s,
			     short& tblIdx,
			     unsigned& idx,
			     t_uchar& cRes) ;

    char* thisStrSymbolAmp (char* s) ;

private:
    int thisFillUpTables () ;

    gString sEntStr;
    gString sOriStr;  // Original string

    // Operators,empty
    gHtmlString (gHtmlString& ) ; //empty
    gHtmlString& operator= (gHtmlString& ) ; //empty
};
////////////////////////////////////////////////////////////
#endif //X_GDNETSTRINGS_H

