// gdSnarfCommon.cpp -- Version 1.0

#include <string.h>
#include "gdSnarfCommon.h"
////////////////////////////////////////////////////////////
FILE* gdOptUnweb::DumpStream ()
{
 ASSERTION(fDump!=nil,"fDump!=nil");
 return fDump;
}
////////////////////////////////////////////////////////////
sOptSnarf::~sOptSnarf ()
{
 delete unwebOpt;
 if ( OutStreamWasOpened() ) fclose( fOut );
}

bool sOptSnarf::HasSpecURI ()
{
 return strcmp( myURI.Str(), myURI.GetOriginalStr() )!=0;
}

FILE* sOptSnarf::OutStream ()
{
 ASSERTION(fOut!=nil,"fOut!=nil");
 return fOut;
}

gdOptUnweb& sOptSnarf::UnwebOpt ()
{
 ASSERTION(unwebOpt!=nil,"unwebOpt!=nil");
 return *unwebOpt;
}

int sOptSnarf::ShowStats (FILE* fStat, gTimerTic& tic, t_gTicElapsed cpuTics)
{
 t_uint32 elapsedMilisec;
 t_uint32 inOctets = GetInOctets();
 t_uint32 paceMade;
 float octPerSec;

 if ( fStat==nil ) return -1;

 elapsedMilisec = tic.GetMilisec();
 octPerSec = (float)inOctets / (elapsedMilisec==0 ? 0.001 : (float)elapsedMilisec);
 fprintf(fStat,"Stats (in miliseconds):\nTotal: CPU_used=%0.0f ms, elapsed=%u ms\n",
	 (float)tic.GetMilisecsFromTics( cpuTics ),
	 elapsedMilisec);
 if ( isVerbose==true || inOctets>1000 ) {
     fprintf(fStat,"Total octets: %u\n",inOctets);
     if ( nStat>2 ) {
	 paceMade = vStat[3].GetUInt();
	 fprintf(fStat, "Head reply: %u ms, content reply: %u ms, client pace: %u ms\n",
		 vStat[1].GetUInt(),
		 vStat[2].GetUInt()-paceMade,
		 paceMade);
     }
     fprintf(fStat,"Throughput (Octets/s): in=%0.1f\n",octPerSec);
 }

 return 0;
}

int sOptSnarf::GoCmdHttp (gURI& aURI)
{
 int thisError;
 char* strOriginal = aURI.GetOriginalStr();

 thisError = aURI.IsOkScheme()==false;
 if ( thisError!=0 ) return 1;  // Invalid scheme

 // If only a domain is given, without any slashes (e.g. gdthreepic http fuji),
 // then the URI domain is empty (!) and the path is fuji; this is o.k.,
 // as a URI can be just a relative name of a file;
 // we need to assume path as / and the domain is the string itself, as the user intended.
 gString sTemp( aURI.GetPathStr() );
 if ( sTemp.Match( strOriginal ) ) {
     sTemp.Add( '/' );
     resultURI.SetString( sTemp.Str() );
 }
 else {
     // Just copy aURI into resultURI
     resultURI.SetString( aURI.GetOriginalStr() );
 }

 return thisError;
}
////////////////////////////////////////////////////////////

