#ifndef X_GDSNARFCOMMON_H
#define X_GDSNARFCOMMON_H

#include "garg.h"
#include "gfile.h"
#include "gnet.h"
#include "gtime.h"
#include "gcalendar.h"
#include "gweb.h"
#include "ghttp.h"
#include "gstringext.h"

#include "gHtmlOpt.h"

////////////////////////////////////////////////////////////
class gdOptUnweb : public gList {
public:
    gdOptUnweb ()
	: fDump( stdout ),
	  fTemp( nil ) {
    }
    ~gdOptUnweb () {
	delete fTemp;
	if ( DumpStreamWasOpened() ) fclose( fDump );
    }

    // Public members
    gHtmlOpt htmlOpt;

    FILE* fDump;
    gFileTemp* fTemp;

    // Get methods
    virtual bool DumpStreamWasOpened () {
	return fDump!=nil && fDump!=stdout && fDump!=stderr;
    }

    virtual FILE* DumpStream () ;

private:
    // Operators,empty
    gdOptUnweb (gdOptUnweb& ) ; //empty
    gdOptUnweb& operator= (gdOptUnweb& ) ; //empty
};
////////////////////////////////////////////////////////////
struct sOptProxy {
    sOptProxy ()
	: port( 0 ) {
    }
    gString sHost;
    t_gPort port;
    // Get methods
    bool IsValid () {
	return sHost.IsEmpty()==false && port>0;
    }
    // Set methods
    void Reset () {
	sHost.SetEmpty();
	port = 0;
    }
};
////////////////////////////////////////////////////////////
struct sOptSnarf {
    sOptSnarf ()
	: isVerbose( false ),
	  isVeryVerbose( false ),
	  doDosMode( false ),
	  doView( false ),
	  doUnweb( false ),
	  doShowStats( false ),
	  doError4NotFound( false ),
	  myPort( 80 ),
	  myURI( gURI::e_http ),
	  myProto( (char*)"1.1" ),  // Default, e.g. HTTP/1.1
	  unwebOpt( nil ),
	  fOut( stdout ),
	  readOctets( 0 ),
	  nStat( -1 ),
	  resultURI( gURI::e_http ) {
    }
    ~sOptSnarf () ;

    bool isVerbose, isVeryVerbose;
    bool doDosMode;
    bool doView;
    bool doUnweb;
    bool doShowStats;
    bool doError4NotFound;
    t_gPort myPort;
    // ...-opt-ins
    gURI myURI;
    gString myProto;
    gString myProxy;
    gString sOutFileName;
    gString sFileDumpReply;
    // Specific members
    gdOptUnweb* unwebOpt;
    FILE* fOut;
    t_uint32 readOctets;
    short nStat;
    gUInt vStat[10];
    // .
    gURI resultURI;

    // Get methods
    bool HasSpecURI () ;

    bool HasProxy () {
	return myProxy.IsEmpty()==false;
    }
    t_uint32 GetInOctets () {
	return readOctets;
    }
    gString& GetProxy () {
	 return myProxy;
    }

    char* NewLine () {
	return (char*)(doDosMode ? "\r\n" : "\n");
    }

    FILE* OutStream () ;

    bool OutStreamWasOpened () {
	return fOut!=nil && fOut!=stdout && fOut!=stderr;
    }

    gdOptUnweb& UnwebOpt () ;

    // Specific methods
    ///int ProxyValidate (gString& sProxyName, t_uint16& rProxyPort) ;
    // .

    // Help methods
    int ShowStats (FILE* fStat, gTimerTic& tic, t_gTicElapsed cpuTics) ;

    // Go methods
    int GoCmdHttp (gURI& aURI) ;
};
////////////////////////////////////////////////////////////
#endif //X_GDSNARFCOMMON_H

