// gdSnarfHttp.cpp -- Version 1.0

#ifndef X_GDSNARFHTTP_H
#define X_GDSNARFHTTP_H

#include "gdSnarfCommon.h"
#include "gBHttp.h"
////////////////////////////////////////////////////////////
class gdHttpURI : public gURI {
public:
    gdHttpURI (gURI& aURI, gString& sInProxy, t_gPort myPort=80) ;
    gdHttpURI (gURI& aURI) ;
    virtual ~gdHttpURI () ;

    virtual bool IsOk () ;

    virtual gString& ConnectHost () {
	return sConnectHost;
    }

    virtual char* ConnectHostStr () {
	return sConnectHost.Str();
    }

    virtual gString& ContentHost () {
	return sContentHost;
    }

    virtual char* ContentHostStr () {
	return sContentHost.Str();
    }

    virtual gString& Path () {
	return sPath;
    }

    virtual char* PathStr () {
	return sPath.Str();
    }

    virtual t_gPort Port () {
	return uPort;
    }

    // Special methods
    virtual char* ParseProxyStr (gString& sInProxy, bool& isProxyOk, sOptProxy& resultProxy) ;

protected:
    gString sConnectHost;
    gString sContentHost;
    gString sPath;
    sOptProxy proxy;
    t_gPort uPort;

    int thisProcessHttpURI (gURI& aURI, gString& sInProxy, t_gPort& myPort) ;

private:
    bool isHttpOk;

    // Operators,empty
    gdHttpURI (gdHttpURI& ) ; //empty
    gdHttpURI& operator= (gdHttpURI& ) ; //empty
};
////////////////////////////////////////////////////////////
class gdHttpSnarf : public gXHttpCont {
public:
    gdHttpSnarf (gTcpConnect& connection) ;
    virtual ~gdHttpSnarf () ;

    // Get methods
    virtual gString& GetReply () ;

    virtual gBigBuffer::eBufferKind BufferKind () {
	return GetBuffer().GetBufferKind();
    }

    virtual t_uchar* UBuffer () {
	return GetBaseBuffer().uBuf;
    }

    virtual int HttpCode () ;

    virtual char* HttpCodeStr () {
	return replyHeader.kindsL.Str(1);
    }

    virtual unsigned GetHeaderLines (char* sKind, gList& resultL) ;

    // Special methods
    virtual bool SnarfContent (gString& sHost, gString& sPath) ;

    virtual int FileInOut (gFileTemp& fT, FILE* fOut) ;

    // Show methods
    virtual int DoPrint (FILE* fOut) ;

protected:
    t_uint64 usedSize;
    gString sReply;

private:
    // Operators,empty
    gdHttpSnarf (gdHttpSnarf& ) ; //empty
    gdHttpSnarf& operator= (gdHttpSnarf& ) ; //empty
};
////////////////////////////////////////////////////////////
#endif //X_GDSNARFHTTP_H

