#include "gdSnarfTxt2Cont.h"  // Build HTML-objs from text
////////////////////////////////////////////////////////////
gdTxtCouple::gdTxtCouple (unsigned lineNr)
    : ptrCouple( nil )
{
 thisInitTxtCouple( lineNr, nil );
}

gdTxtCouple::gdTxtCouple (unsigned lineNr, char* str)
    : ptrCouple( nil )
{
 // E.g.: "<a HrEf=abc Attr1=Val1>"
 // Couple() will contain the anchor tag, with 2 attributes within ptrCouple->attrL
 // .
 thisInitTxtCouple( lineNr, str );
}

gdTxtCouple::~gdTxtCouple ()
{
 delete ptrCouple;
}

bool gdTxtCouple::IsOk ()
{
 return ptrCouple!=nil;
}

char* gdTxtCouple::GetStr ()
{
 if ( IsOk()==false )
     return nil;
 return Str( 1 );
}

gdHCouple* gdTxtCouple::CouplePtr ()
{
 return ptrCouple;
}

gdHCouple& gdTxtCouple::Couple ()
{
 ASSERTION(ptrCouple!=nil,"ptrCouple!=nil");
 return *ptrCouple;
}

void gdTxtCouple::Show (bool doShowAll)
{
 if ( ptrCouple==nil ) return;

 if ( doShowAll ) gList::Show( true );

 printf("DBG: [Line:%u] original-str='%s'\n",ptrCouple->iLine,Str(1));
 printf("Couple->GetStr()='%s' (idTag=%d Tag?%c)\n",ptrCouple->GetStr(),ptrCouple->idTag,ISyORn(ptrCouple->IsText()==false));
 printf("Couple->GetHRef()='%s', IsAnchor()?%c\n",ptrCouple->GetHRef(),ISyORn(ptrCouple->IsAnchor()));
 printf("LST:"); ptrCouple->Show( true ); printf("[[EOX]]-LST\n");

 // Show attributes
 short iAttr, nAttr = ptrCouple->attrL.N();
 printf("attrL(nAttr=%d):\n",nAttr);
 for (iAttr=1; iAttr<=nAttr; iAttr++) {
     printf("[%s|",ptrCouple->attrL.GetAttr(iAttr));
     printf("%s]\n",ptrCouple->attrL.GetAttrValue(iAttr));
 }
 printf("[[EOX]]-attrL\n");
 //printf("Find(HREF)=[%s]\n",ptrCouple->attrL.Find( "HREF", true/*doUnquote*/ ));
}

int gdTxtCouple::thisInitTxtCouple (unsigned lineNr, char* str)
{
 gString s;
 gString sTagLst;
 char* strTag = nil;
 char* sAttrLst = nil;
 unsigned n, len;

 if ( str==nil ) {
     ptrCouple = new gdHCouple( lineNr, "\0" );
     return 0;
 }

 s.Set( str );
 s.Trim();
 Add( s.Str() );
 len = s.Length();
 if ( s[1]=='<' ) {
     if ( len<=2 || s[len]!='>' ) return -1;
     sTagLst.CopyFromTo( s, 2, len-1 );
     sTagLst.Trim();
     gParam aParam( sTagLst.Str(), " ", gParam::e_StopSplitOnFirst );
     n = aParam.N();
     strTag = aParam.Str( 1 );
     if ( n>1 ) {
	 sAttrLst = aParam.Str( 2 );
     }
     ptrCouple = new gdHCouple( lineNr, strTag, sAttrLst );
 }
 else {
     ptrCouple = new gdHCouple( lineNr, s.Str() );
 }
 ASSERTION(ptrCouple!=nil,"ptrCouple!=nil");
 return 0;
}
////////////////////////////////////////////////////////////

