#ifndef gCALENDAR_X_H
#define gCALENDAR_X_H

#include <time.h>  //gmtime/localtime, mktime, (struct tm) ...
#include "gstorage.h"
////////////////////////////////////////////////////////////
class gDateTime : public gStorage {
public:
    enum eKindTime {
	e_Now
    };

    gDateTime (t_stamp aStamp=0) ;
    gDateTime (int iYear, int iMonth, int iDay,
	       t_uint8 uHour=0, t_uint8 uMin=0, t_uint8 uSec=0) ;
    gDateTime (eKindTime aKind) ;
    virtual ~gDateTime ();

    // Public data-members
    int lastOpError;
    t_int16 year;
    t_uint8 month;
    t_uint8 day;
    t_uint8 hour, minu, sec;
    t_uint8 wday;  //day of the week (0=sunday)
    t_uint16 yday; //day of the year
    t_int8 isdst;  //daylight saving time (-1 on error)
    static int minimumYear;

    // Get methods
    virtual bool IsOk () ;
    virtual char* StorageName () ;

    // Set methods
    virtual void Reset () ;
    virtual int SetError (int opError) ;

    // Specific methods
    virtual t_stamp GetTimeStamp () ;
    virtual bool SetTimeStamp (t_stamp aStamp) ;
    t_uint8 DaysOfMonth (int aYear, t_uint8 aMonth) ;
    // .

    // Save/etc methods
    virtual gStorage* NewObject () ;
    virtual t_uchar* ToString (t_uchar* uBuf) ;
    virtual bool SaveGuts (FILE* f) ;
    virtual bool RestoreGuts (FILE* f) ;

protected:
    static const t_uint8 tblCalDurMonth[13];

    // Protected methods
    int thisCalCheck () ;
    int thisDateTimeCheck (gDateTime& aDtTm, int minYear) ;
    int thisDateCheck (int aYear, t_uint8 aMonth, t_uint8 aDay, int minYear) ;
    int thisTimeCheck (t_uint8 aHour, t_uint8 aMin, t_uint8 aSec) ;

    int thisConvertFromStamp (t_stamp aStamp) ;
    int thisConvertToStamp (gDateTime& aDtTm, t_stamp& aStamp) ;
    int thisConvertTo_libc_tm (gDateTime& aDtTm, struct tm* pTM) ;

private:
    // Operators,empty
    gDateTime (gDateTime& ) ; //empty
    gDateTime& operator= (gDateTime& ) ; //empty
};
////////////////////////////////////////////////////////////
class gTimeStamp : public gUInt {
public:
    gTimeStamp (t_stamp aStamp=0) ;
    gTimeStamp (gDateTime& aDtTm) ;
    virtual ~gTimeStamp () ;

    // Public data-members
    short iValid;

    // Get methods
    virtual bool IsOk () ;
    // .

    // Set methods
    bool SetStamp (t_stamp aStamp) ;
    virtual bool SetUInt (unsigned v) ;

private:
    // Operators,empty
    gTimeStamp (gTimeStamp& ) ; //empty
    gTimeStamp& operator= (gTimeStamp& ) ; //empty
};
////////////////////////////////////////////////////////////
#endif //gCALENDAR_X_H

