#ifndef gCONTROL_X_H
#define gCONTROL_X_H

#include "glist.h"
////////////////////////////////////////////////////////////
class gControl : public gStorage {
public:
    gControl (eStorage aKind=e_Control) ;
    virtual ~gControl () {
    }

    // Public data-members
    int lastOpError;
    int dbgLevel;
    static int nErrors[ LOG_LOGMAX ];
    static gList lLog[ LOG_LOGMAX ];

    // Get methods
    virtual bool IsOk () {
	return lastOpError==0;
    }

    virtual char* GetErrorStr () {
	return sStrError;
    }

    virtual t_uint16 GetRandom (t_uint16 maxRange) ;

    virtual int MinimumStorageSize () {
	return 0;
    }
    virtual int MaximumStorageSize () {
	return 0;
    }

    // Set methods
    virtual void Reset () ;

    virtual void ResetLog () ;

    virtual int SetDefaultDbgLevel (int aDbgLevel) {
	return dbgLevelDefault = aDbgLevel;
    }

    virtual int SetError (int opError) ;

    // Special methods
    int Log (FILE* dbgFile, int level, const char* formatStr, ...) ;
    virtual int ClearLogMem (int level) ;
    virtual int ClearLogMemAll () ;
    virtual int ClearAllLogs () ;

    // Save/etc methods
    virtual gStorage* NewObject () ;
    virtual t_uchar* ToString (t_uchar* uBuf) {
	return nil;
    }
    virtual bool SaveGuts (FILE* f) {
	return CanSave( f );
    }
    virtual bool RestoreGuts (FILE* f) {
	return CanRestore( f );
    }

protected:
    char sStrError[200];
    static int dbgLevelDefault;
    static char logBuf[4096];

private:
    static short intCtrl;

    // Operators,empty
    gControl (gControl& ) ; //empty
    gControl& operator= (gControl& ) ; //empty
};
////////////////////////////////////////////////////////////
class gStorageControl : public gControl {
public:
    virtual ~gStorageControl () ;

    static gStorageControl& Self () {
        return myself;
    }

    // Public data-members
    static short assertedNr;

    // Get methods
    virtual int NumObjs () ;

    virtual char* StorageKindName (short refKind) ;

    // Set methods
    void StaticAlloc (char* msgStr, int incrNrStaticStgObjs) ;

    // Multi-Service methods
    bool IsServiceUsed (short servIdx) ;
    char* GetServiceName (short servIdx) ;
    sStorageDesc& GetServiceDescriptor (short servIdx) ;
    sServiceRegister& GetService (char* descStr) ;
    sServiceRegister* GetServicePtr (char* descStr) ;
    short RegisterService (char* descStr, short refKind, short servIdx=-1) ;
    void ServiceAlloc (char* descStr, unsigned nNodes=0) ;
    bool ServiceAdd (char* descStr, sServiceNode& aNode) ;
    bool ServiceDelete (char* descStr, gStorage* pStorage) ;

    // Method only called by FileControl
    void Release () ;

protected:
    gStorageControl () ;

    // Multi-service data-members
    short nServices;
    static sServiceRegister* pServReg;

    short thisFindService (char* descStr, short& refKind) ;

private:
    static int rStaticStgObjs;
    static short maxServices;
    static gStorageControl myself;

    // Operators,empty
    gStorageControl (gStorageControl& ) ; //empty
    gStorageControl& operator= (gStorageControl& ) ; //empty
};
////////////////////////////////////////////////////////////
#endif //gCONTROL_X_H

