// ghttp.cpp -- Version 0.8

// Removed lots of methods, now within gNetInfo/src/gXHttp...!
// Now no content classses, only 'gHttpGeneric'.

#include <string.h>  //memcpy, ...
#include "ghttp.h"
#include "gstringext.h"
#include "garg.h"

// Static members
gURI::sSchemeUse gURI::schemeTbl[]={
    { gURI::e_ftp, "ftp", 1738 },
    { gURI::e_http, "http", 2616 },
    { gURI::e_file, "file", 0 },
    { gURI::e_invalid, NULL, -1 }
    // Note: rfcCode=0 means no RFC; non-zero means special RFC name
};
////////////////////////////////////////////////////////////
gVersion::gVersion (short major, short minor)
    : vMajor( major ),
      vMinor( minor )
{
}

bool gVersion::SetVersion (gString& s)
{
 // Must be X, or X.Y (X and Y numerical)
 gParam param( s, "." );
 unsigned n = param.N();
 if ( n<1 ) return false;
 vMinor = -1;
 if ( n<2 ) {
     return thisSetMajorOrMinor( s.Str(), vMajor )==0;
 }
 vMajor = -1;
 // && forces both to be correct (both evaluated)
 return
     thisSetMajorOrMinor( param.Str(1), vMajor )==0 &&
     thisSetMajorOrMinor( param.Str(2), vMinor )==0;
}

bool gVersion::operator> (gVersion& version)
{
 if ( vMajor > version.vMajor ) return true;
 if ( vMajor < version.vMajor ) return false;
 return vMinor > version.vMinor;
}

bool gVersion::operator< (gVersion& version)
{
 if ( vMajor < version.vMajor ) return true;
 if ( vMajor > version.vMajor ) return false;
 return vMinor < version.vMinor;
}

int gVersion::thisSetMajorOrMinor (char* s, short& ver)
{
 // Returns 0 on success
 t_uint32 m=0;
 int error = gStrControl::Self().ConvertToUInt32( s, m );
 if ( error!=0 ) return error;
 if ( m>(t_uint32)MAX_INT16_I ) return -1;
 ver = (short)m;
 return 0;
}
////////////////////////////////////////////////////////////
gBigBuffer::gBigBuffer (t_uint32 bufSize)
    : baseBuf( nil ),
      isDynamic( bufSize==0 ),
      usedSize( 0 ),
      nNodes( 0 ), maxNodes( 10 ),
      bNode( nil ),
      fTemp( nil ),
      hasOverbuffer( false ),
      baseSizeBuf( 0 )
{
 if ( isDynamic ) bufSize = 0x1000;  //at least 4096 starting size
//#ifdef DEBUG_HTTP
// if ( isDynamic ) bufSize = 4;
//#error nop...just for testing...
//#endif //DEBUG_HTTP
 thisAllocateBuf( bufSize );
}

gBigBuffer::~gBigBuffer ()
{
 delete baseBuf;
 if ( bNode!=nil ) {
     for (unsigned idxNode=0; idxNode<maxNodes; idxNode++) delete bNode[ idxNode ];
     delete[] bNode;
 }
 // Finally delete temporary file
 delete fTemp;
}

gBigBuffer::eBufferKind gBigBuffer::GetBufferKind ()
{
 if ( hasOverbuffer ) return e_InFile;
 return GetNumberNodes()==0 ? e_NormalRAM : e_NodesRAM;
}

gUCharBuffer* gBigBuffer::GetNode (unsigned idxNode)
{
 ASSERTION(idxNode<nNodes,"idxNode<nNodes");
 gUCharBuffer* sBuf = bNode[ idxNode ];
 ASSERTION(sBuf!=nil,"sBuf!=nil");
 return sBuf;
}

gFileTemp& gBigBuffer::GetFile ()
{
 ASSERTION(fTemp!=nil,"fTemp!=nil");
 return *fTemp;
}

bool gBigBuffer::NewFile ()
{
 // Returns always true
 delete fTemp;
 fTemp = new gFileTemp( "htc" );
 ASSERTION(fTemp!=nil,"fTemp!=nil");  // Must create temp file!
 return true;
}

bool gBigBuffer::WriteBuf (int fHandle, gUCharBuffer& sBuf, unsigned nBytes)
{
 // If the buffer is written, we assume 'overbuffer'
 hasOverbuffer = true;
 return thisWrite( fHandle, sBuf, nBytes )==0;
}

bool gBigBuffer::Flush (unsigned nBytes)
{
 bool doNeedNode = usedSize>0;
 unsigned idxNode;

 ASSERTION(baseBuf!=nil,"Flush(1)");
 if ( nBytes==0 ) return true;
 if ( doNeedNode==false ) return true;

 if ( nNodes>=maxNodes ) {
     return thisOverbuffer( nBytes )==0;
 }
 idxNode = nNodes++;
 ASSERTION(bNode[idxNode]==nil,"bNode[idxNode]==nil");
 bNode[ idxNode ] = new gUCharBuffer( nBytes+1 );
 gUCharBuffer* sBuf = bNode[ idxNode ];
 ASSERTION(sBuf!=nil,"Flush(2)");
 memcpy( sBuf->uBuf, baseBuf->uBuf, (size_t)(sBuf->size = nBytes) );
 // Re-allocate base-buffer
 delete baseBuf;
 baseBuf = new gUCharBuffer( baseSizeBuf+1 );
 ASSERTION(baseBuf!=nil,"Flush(3)");
 return true;
}

bool gBigBuffer::thisAllocateBuf (t_uint32 bufSize)
{
 if ( bufSize==0 ) return true;
 //if ( bufSize>=MAX_HTTP_CHUNK_SIZE ) {
 //	fprintf(stderr,"Trying to allocate a buffer too big: %ld/%ld\n",(long)bufSize,(long)MAX_HTTP_CHUNK_SIZE);
 //	ASSERTION_FALSE("thisAllocateBuf(1)");
 //}
 ASSERTION(bufSize<MAX_HTTP_CHUNK_SIZE,"thisAllocateBuf(1)");
 baseSizeBuf = bufSize;
 baseBuf = new gUCharBuffer( bufSize+1 );
 bNode = new gUCharBuffer*[ maxNodes ];
 ASSERTION(bNode!=nil,"thisAllocateBuf(2)");
 for (unsigned idxNode=0; idxNode<maxNodes; idxNode++) bNode[ idxNode ] = nil;
 return baseBuf!=nil;
}

int gBigBuffer::thisOverbuffer (unsigned nBytes)
{
 unsigned idxNode;

 hasOverbuffer = true;
 if ( fTemp==nil ) {
     fTemp = new gFileTemp( "htp" );
     ASSERTION(fTemp!=nil,"fTemp!=nil");
     // (1st): Flush all nodes into the file
     for (idxNode=0; idxNode<nNodes; idxNode++) {
	 ASSERTION(bNode[idxNode]!=nil,"bNode[idxNode]!=nil");
	 if ( thisWrite( fTemp->fHandle, *bNode[idxNode], nBytes )!=0 ) return 2;
     }
 }
 // Write the baseBuf
 return thisWrite( fTemp->fHandle, *baseBuf, nBytes )!=0 ? 2 : 0;
}

int gBigBuffer::thisWrite (int fHandle, gUCharBuffer& sBuf, unsigned nBytes)
{
 // Returns 0 on success
 if ( gFileControl::Self().Write( fHandle, sBuf.uBuf, nBytes ) ) return 0;
 return gFileControl::Self().lastOpError;
}
////////////////////////////////////////////////////////////
gURI::gURI ()
    : lastOpError( 0 ),
      pathType( e_NoType ),
      scheme( gURI::e_invalid ),
      isOkScheme( true )
{
}

gURI::gURI (eScheme aScheme)
    : lastOpError( 0 ),
      pathType( e_NoType ),
      scheme( aScheme ),
      isOkScheme( true )
{
}

gURI::~gURI ()
{
}

bool gURI::IsOk ()
{
 return IsOkScheme()==true && pathType!=e_NoType;
}

char* gURI::Str ()
{
 return gString::Str();  // Check if this is enough
}

bool gURI::SetString (char* s)
{
 // Re-initialize data-members
 sDomain.SetEmpty();
 sPath.SetEmpty();
 sOriginal.SetEmpty();
 if ( s==nil ) return false;
 // ...and assign relevant ones:
 sOriginal.Set( s );
 gString sTemp( s );
 lastOpError = thisParseString( sTemp.Str(), scheme );
 DBGPRINT("DBG: gURI::SetString(%s), lastOpError=%d, scheme=%d\n",s,lastOpError,scheme);
 return lastOpError==0;
}

bool gURI::IsValidDomain ()
{
 bool isOkDomain = sDomain.Find('/')==0;
 if ( sDomain.Find(' ') ) return false;
 // For now, just checking this, not the chars in the domain name...
 return isOkDomain;
}

int gURI::thisParseString (char* s, eScheme aScheme)
{
 int error = 0;
 unsigned pos;
 bool hasSpecScheme;

 ASSERTION(s!=nil,"s!=nil");
 pathType = e_NoType;

 // Refer to BNF syntax on W3-ORG:
 // (Index: http://www.w3.org/Addressing/URL/URI_Overview.html)
 // => http://www.w3.org/Addressing/URL/5_URI_BNF.html

 // uri ::= scheme : path [ ? search ]
 // scheme ::= alpha [ xalphas ]
 // xalphas ::= ONE OR MORE xalpha
 // xalpha ::= alpha | digit | safe | extra | escape
 // safe ::= $ | - | _ | @ | . | &
 // extra ::= ! | * | " | ' | ( | ) | ,
 // escape ::= % hex hex

 // A colon (:) may be present or not
 isOkScheme = false;
 pos = gStrControl::Self().Find( s, ':' );
 if ( (hasSpecScheme = pos>0)==true ) {
     // Strip schema and check-it
     s[ pos-1 ] = 0;
     eScheme inputScheme( thisGetSchemeFromString( s, error ) );
     s += pos;  // Not fancy but efficient...
     if ( error==0 ) {
	 // Scheme input is what we expected ?
	 // If no scheme was specified (e_invalid) any input scheme is accepted
	 if ( aScheme!=e_invalid && inputScheme!=aScheme ) {
	     error = 4;
	 }
     }
     DBGPRINT("DBG: inputScheme=%d, requested scheme=%d, error=%d\n",inputScheme,aScheme,error);
 }

 if ( error!=0 ) return error;
 isOkScheme = true;
 //
 // Check remaining " :" =\/=> " path [ ? search ]"
 //
 // The 'path' _can_ surely start with // (double slash)
 // NOTE 1: Why _can_ ?
 //         Refer to "Hierarchies and Relative URIs" at http://www.w3.org/DesignIssues/Axioms.html
 //
 // When a scheme "XYZ:" is specified it is normally assumed an absolute path via double-slash.

 pos = s[0]=='/';
 if ( pos==1 ) {
     pos += s[1]=='/';
     s += pos;
     pathType = pos>=2 ? e_Absolute : e_RelativeQualified;
 }
 else {
     pathType = e_Relative;
 }
 return thisSetDomainPath( s, hasSpecScheme, aScheme );
}

int gURI::thisSetDomainPath (char* s, bool hasSpecScheme, eScheme aScheme)
{
 gString aStr( s );
 unsigned pos;
 pos = aStr.Find( '/' );
 if ( pos<=1 ) {
     // e.g.1: "http://fuji"=\/=> "fuji" has no slash,
     // therefore the domain is "fuji" and path is nil
     // e.g.2: "http:///fuji"=\/=> "/fuji" has a leading slash,
     // therefore the domain is invalidly "/fuji"
     // e.g.3: "//afile" : the domain is not 'afile',
     // because it was not specified the protocol.
     if ( hasSpecScheme==false ) {
	 // This fits into example 3!
	 return thisSetPath( s );
     }
     sDomain.Set( s );
     return thisSetPath( nil );
 }
 // Here the domain has at least one char,
 // e.g. "http://f/mypath" or "http://f/mypath/"
 //      or just "http://f/"
 pos--;
 sDomain.CopyFromTo( aStr, 1, pos );
 return thisSetPath( s+pos );
}

int gURI::thisSetPath (char* s)
{
 // Return 0 if o.k.
 // (i.e. non-empty path)
 ;
 if ( s==nil ) {
     Set( sDomain.Str() );
     return 0;
 }
 if ( s[0]==0 ) {
     Set( sDomain.Str() );
     // Empty path, thus considering only domain
     return 1;
 }
 // If a path ('s') does not start with a slash,
 // then the domain is empty, and the path
 // effectively starts by '/' if it is an absolute domain
 if ( s[0]!='/' ) {
     gString aPath( pathType==e_Absolute ? '/' : '\0' );
     aPath.Add( s );
     Set( aPath.Str() );
     sPath.Set( Str() );
     return 0;
 }
 Set( sDomain.Str() );
 Add( s );
 sPath.Set( s );
 return 0;
}

gURI::eScheme gURI::thisGetSchemeFromString (char* s, int& error)
{
 int i;
 char c, lowChar;
 bool isValid;
 bool isEscape;
 eScheme aScheme;

 error = (int)e_invalid;  // Invalid characters used (error-code 2 is not-found!)

 ASSERTION(s!=nil,"s!=nil");
 for (i=0; (c = s[i])!='\0'; ) {
     // Validate all characters are xalpha
     lowChar = ( c>='A' && c<='Z' ) ? c+'a'-'A' : c;
     s[ i++ ] = lowChar;  // Changes passed string 's' (and increments cycle index)
     isEscape = lowChar=='%';
     isValid =
	 (lowChar>='a' && lowChar<='z') ||
	 (lowChar>='0' && lowChar<='9') ||
	 lowChar=='$' || lowChar=='-' || lowChar=='_' ||
	 lowChar=='@' || lowChar=='.' || lowChar=='&' ||
	 lowChar=='!' || lowChar=='*' || lowChar=='"' ||
	 lowChar=='\'' || lowChar=='(' || lowChar==')' ||
	 lowChar==',' || isEscape==true;
     if ( isValid==false ) return e_invalid;
     if ( isEscape ) {
	 c = s[ i++ ];
	 isValid = (c>='0' && c<='9') || (c>='a' && c<='f');  // If is nul char, is false...
	 if ( isValid==false ) return e_invalid;
	 c = s[ i++ ];
	 isValid = (c>='0' && c<='9') || (c>='a' && c<='f');  // If is nul char, is false...
	 if ( isValid==false ) return e_invalid;
     }
 }//end FOR

 // If we get here, we know for sure all characters are ok,
 // now we fetch them
 error = thisFetchScheme( s, aScheme )<0 ? 2 : 0;
 return aScheme;
}

int gURI::thisFetchScheme (char* s, eScheme& foundScheme)
{
 int i;
 short rfcCode;
 char* name;

 ASSERTION(s!=nil,"s!=nil");
 foundScheme = e_invalid;

 for (i=0; (rfcCode = schemeTbl[i].rfcCode)>=0; i++) {
     name = schemeTbl[i].name;
     if ( gStrControl::Self().Match( s, name ) ) {
	 foundScheme = schemeTbl[i].theScheme;
	 return i;
     }
 }
 return -1;
}
////////////////////////////////////////////////////////////
gHttpGeneric::gHttpGeneric (gTcpConnect& connection)
    : pConnection( &connection )
{
}

gHttpGeneric::~gHttpGeneric ()
{
}

gUCharBuffer& gHttpGeneric::GetBaseBuffer ()
{
 gUCharBuffer* sBuf;
 sBuf = GetBuffer().baseBuf;
 ASSERTION(sBuf!=nil,"sBuf!=nil");
 return *sBuf;
}

gBigBuffer& gHttpGeneric::GetBuffer ()
{
 ASSERTION_FALSE("TODO");
 return biffBuffer;
}
////////////////////////////////////////////////////////////

