#!/bin/sh

# Makes gnetinfo static (no shared-libraries)

# You can use any args to specify g++ options, e.g. "-DDEBUG"


[ "$REL_PATH" = "" ] && REL_PATH=../../../gprog

for LIB_PATH in \
	$REL_PATH/gsrc/gobj \
	$REL_PATH/gsrc/gbhtml \
	../src \
	; do
    for F in ${LIB_PATH}/*.cpp ${LIB_PATH}/*.h ; do
    	[ ! -f "$F" ] && continue
	ln -s $F
    done
done

NONE=1
for X in *.h ; do
    [ -f "$X" ] && NONE=0
done
[ $NONE = 1 ] && exit 1

for X in *.cpp ; do
    [ "$X" = "*.cpp" ] && continue
    DEFS="-g $*"
    OBJ=`echo $X | sed 's/\.cpp/.o/'`
    [ "$OBJ" = "" ] && continue
    LINE="g++ -Wall $DEFS -c $X -o $OBJ"
    [ -f $OBJ ] && continue
    echo "Compiling: $LINE"
    $LINE
done

echo "Linking..."
g++ *.o -o gnetinfo_static
RES=$?

exit $RES

