// gNetInfo2.cpp -- Version 2.9
//	(brevision 029)

// This version was entirely copied from gNetInfo.cpp version 0.8, to use a basic lib: gbhtml

#define thisProgramVersion "Version 2.9"
#define thisProgramCopyright "Prized Season & Sons"
#define thisProgramYear 2009
#define thisProgramCopy "This is free software (GPL)\n\
There is no warranty, not even for MERCHANTABILITY or\n\
FITNESS FOR A PARTICULAR PURPOSE."

#include <stdio.h>
#include <string.h>
#include "garg.h"
#include "gfile.h"
#include "gnet.h"
#include "gtime.h"
#include "gcalendar.h"
#include "gweb.h"
#include "gstringext.h"
#include "gconfig.h"
#include "gfilestat.h"

#include "gBNetHttpRequest.h"
#include "gBHttpProxy.h"
#include "gBStreamEtc.h"

#include "gNetinfoHttp.h"

#ifdef gDOS_SPEC
#include <windows.h>
#endif //gDOS_SPEC

#ifdef gGX_SIG_SUPPORT
#include <signal.h>
#endif //gGX_SIG_SUPPORT
////////////////////////////////////////////////////////////
struct sOptNetInfo {
    sOptNetInfo ()
	: isVerbose( false ),
	  isVeryVerbose( false ),
	  isVeryMostVerbose( false ),
	  doDosMode( false ),
	  doForce( false ),
	  doUnweb( false ),
	  doPace( false ),
	  doShowStats( false ),
	  doError4NotFound( false ),
	  myPort( 80 ),
	  secTimeout( 0 ),
	  myURI( gURI::e_http ),
	  myProto( (char*)"1.1" ),  // Default, e.g. HTTP/1.1
	  isGetMethod( true ),
	  readOctets( 0 ),
	  nStat( -1 ) {
    }
    ~sOptNetInfo () {
    }
    bool isVerbose, isVeryVerbose;
    bool isVeryMostVerbose;
    bool doDosMode;
    bool doForce;
    bool doUnweb;
    bool doPace;
    bool doShowStats;
    bool doError4NotFound;
    t_gPort myPort;
    unsigned secTimeout;
    // ...-opt-ins
    gURI myURI;
    gString myProto;
    gString myProxy;
    gString sFileOut;
    gString sFileRequest;  // Input request
    gString sFileDumpReply;
    gString sUserAgent;
    gHttpRequestList lReq;
    // Specific members
    sOptProxy proxy;
    bool isGetMethod;
    t_uint32 readOctets;
    short nStat;
    gUInt vStat[10];
    // .

    // Get methods
    bool HasSpecURI () {
	return strcmp( myURI.Str(), myURI.GetOriginalStr() )!=0;
    }
    bool HasProxy () {
	return myProxy.IsEmpty()==false;
    }
    bool HasOutput () {
	return sFileOut.IsEmpty()==false;
    }
    t_uint32 GetInOctets () {
	return readOctets;
    }
    char* GetProxyStr () {
	 return myProxy.Str();
    }
    char* GetProxyStr (bool& isProxyOk, sOptProxy& resultProxy) ;

    bool IsMethodGet () {
	return isGetMethod;
    }

    // Specific methods
    ///int ProxyValidate (gString& sProxyName, t_uint16& rProxyPort) ;
    // .
};

char* sOptNetInfo::GetProxyStr (bool& isProxyOk, sOptProxy& resultProxy)
{
 ;
 // Returns nil if format is invalid, otherwise it returns the host string
 //
 // A valid format is:  HOST:PORT
 // .
 char* str = GetProxyStr();
 unsigned n;
 gParam aParam( str, ":" );

 n = aParam.N();
 resultProxy.Reset();
 isProxyOk = n==2;
 if ( isProxyOk==false ) return nil;
 // Check if host is in a good format
 gString sHost( aParam.Str(1) );
 isProxyOk = sHost.FindExcept( "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789.-_", true )==0;
 if ( isProxyOk==false ) return nil;
 // Check if port is in a good format (decimal positive)
 t_uint32 vRes=0;
 isProxyOk = gStrControl::Self().ConvertToUInt32( aParam.Str(2), vRes )==0;
 if ( isProxyOk==false ) return nil;
 isProxyOk = vRes>0 && vRes<=MAX_UINT16_U;
 resultProxy.sHost = sHost;
 resultProxy.port = (t_gPort)vRes;
 return resultProxy.sHost.Str();
}
////////////////////////////////////////////////////////////
FILE* glob_fRepErr = nil;
////////////////////////////////////////////////////////////
int print_help (char* progStr)
{
 char
     *msgHelp = "%s - %s\n\n\
Usage:\n\
        %s command [OPTION] [HOST ...]\n\
\n\
Commands are:\n\
   hostname     Get host by name\n\
   hostaddr     Get host by addr\n\
   connect      Connect (default: via HTTP)\n\
   http         Retrieve page\n\
   post         Post a request\n\
\n\
Options are:\n\
   -h           This help (or --help / --version)\n\
   -v           Verbose (use twice, more verbose; --most-verbose extra info)\n\
   -d           Force DOS-mode (CR&LF)\n\
   -f           Force output overwrite (or --force)\n\
   -o X         Output to file X (or --output)\n\
   -p X         Use port X (or --port)\n\
   -P version   Protocol version (default is 1.1, for HTTP/1.1)\n\
                (or --protocol)\n\
   -r X         Request file input (or --request)\n\
   -t N         Use N seconds for the timeout\n\
   -u X         Use X as the user-agent (or --user-agent)\n\
   -x X         Use proxy X (or --proxy)\n\
   --stats      Show statistics\n\
   --unweb      Apply unweb\n\
   --no-pace    Do not respect pace (RFC2616, ch.8.2.4)\n\
   --not-found-error   Error-4 when not-found or redirected\n\
   --dump-reply X      Dumps the (HTTP/...) reply to file X\n\
%s";
 const char* msgExtra = "\n\
Examples:\n\
   gnetinfo hostname www.yahoo.com\n\
   gnetinfo hostaddr 68.142.226.38\n\
   gnetinfo http://www.google.com/robots.txt\n\
     (URLs can be shortened into the command)\n\
   gnetinfo http www.sapo.pt -o @@\n\
     (output to a auto-named file)\n\
";

 printf(msgHelp,
	progStr,
	thisProgramVersion,
	progStr,
	msgExtra);

 return 0;
}
////////////////////////////////////////////////////////////
int print_version (char* progStr)
{
 char
     *msgVersion = "%s - %s\n\
Written by Henrique Moreira.\n\
\n\
Copyright (C) %u %s.\n\
%s\n";

 printf(msgVersion,
	progStr,
	thisProgramVersion,
	thisProgramYear,thisProgramCopyright,
	thisProgramCopy);
 return 0;
}
////////////////////////////////////////////////////////////
// glib required functions
////////////////////////////////////////////////////////////
int gglobal_EventTerminate (int v)
{
 DBGPRINT("DBG: gglobal_EventTerminate(%d) <<== START\n",v);
 DBGPRINT("DBG: gglobal_EventTerminate(%d) <<== END\n",v);
 return 0;
}

void NetSignalAlarmHandler (int v)
{
 DBGPRINT("DBG: NetSignalAlarmHandler(%d) <<== START\n",v);
 if ( glob_fRepErr ) fprintf(glob_fRepErr,"Bailing out.\n");
 DBGPRINT("DBG: NetSignalAlarmHandler(%d) <<== END\n",v);
 gEND;
 exit(1);
}

void NilSignalAlarmHandler (int v)
{
 DBGPRINT("DBG: NilSignalAlarmHandler(%d)\n",v);
}
////////////////////////////////////////////////////////////
// Aux functions
////////////////////////////////////////////////////////////
int parse_request_file_input (FILE* fRepErr, gString& sFName, gHttpRequestList& lReq)
{
 int error;
 t_int32 iVal;
 gFileFetch fFetch( sFName );

 error = fFetch.IsOk()==false || fFetch.IsBufferOk()==false/*usually ok*/;
 DBGPRINT_WEB("DBG_WEB: fFetch:%s, error=%d OK?%c,IsBufferOk?%c (doEndNewLine?%c)\n",
	      sFName.Str(),
	      error,
	      ISyORn(fFetch.IsOk()),
	      ISyORn(fFetch.IsBufferOk()),
	      ISyORn(fFetch.doEndNewLine));
 if ( error ) return error*2;  // returns 2 if file is not usable

 unsigned i, n = fFetch.aL.N();
 short state=-1;

 for (i=1; i<=n; i++) {
     char* str = fFetch.aL.Str( i );
     bool isEmpty = str[0]==0;
     gParam par( str, " ", gParam::e_StopSplitOnFirst );
     gString sFirst( par.Str(1) );
     t_uchar lastChr( sFirst[ sFirst.Length() ] );
     DBGPRINT_WEB("DBG_WEB: REQUEST i=%u state=%d, len=%u\t[%s]\n",
		  i, state,
		  strlen( str ),
		  sFirst.Str());
     switch ( state ) {
     case -1:
	 if ( lastChr!=':' ) {
	     if ( fRepErr )
		 fprintf(fRepErr,"Did not start by 'STR: ': '%s'\n",str);
	     return 4;
	 }
	 state = 0;
	 break;
     case 0:
	 if ( isEmpty ) {
	     state = 1;
	     continue;
	 }
	 if ( sFirst.Match( "Content-Length:", true ) ) {
	     if ( gStrControl::Self().ConvertToInt32( par.Str(2), iVal )!=0 ||
		  iVal<=0 ) {
		 if ( fRepErr )
		     fprintf(fRepErr,"Invalid content: '%s'\n",str);
		 return 4;
	     }
	     lReq.iContentLength = iVal;
	 }
	 break;
     case 1:
	 if ( isEmpty ) {
	     if ( fRepErr )
		 fprintf(fRepErr,"Invalid request empty-sequence, line %u\n",i);
	     return 4;
	 }
	 state = 2;
	 break;
     default: // like state 2: full-post text
	 if ( isEmpty ) {
	     if ( fRepErr )
		 fprintf(fRepErr,"Warning: request input line %u is empty.\n",i);
	 }
	 break;
     }
     if ( state>=2 )
	 lReq.lText.Add( str );
     else
	 lReq.Add( str );
     DBGPRINT_WEB("DBG_WEB: REQUEST i=%u state=%d\tlReq.N=%u\n",i,state,lReq.N());
 }
 error = lReq.Consolidate()==false;
 DBGPRINT_WEB("DBG_WEB: REQUEST: end (returns %d)\n",error);
 DBGPRINT_WEB("DBG_WEB: lReq:%s\n",lReq.lText.N()>1?"uops":(lReq.lText.N()==1?"one_line-ok":"no_lines-NotOk"));
 return error;
}
////////////////////////////////////////////////////////////
int invent_new_name (gString& inPath, gString& sPrefix, gString& sSuffix, gString& sPrepend, gString& sOut)
{
 // Returns 1 if it is a default new-name
 gString sPath( inPath );
 unsigned pos = sPath.FindBack( '/' ), len = sPath.Length();

 while ( len>1 && pos==len ) {
     sPath.Delete( len );  // Cut last slash
     pos = sPath.FindBack( '/' );
     len--;
 }

 // If sPrepend is empty, a defaut new-name will be @@output".htm"
 gString sPrependToExtension( sPrepend.IsEmpty() ? (char*)".htm" : sPrepend.Str() );

 DBGPRINT("DBG: inPath='%s' (len=%u,pos=%u), sPrefix='%s', sSuffix='%s', sPrepend='%s'\n",
	  inPath.Str(),
	  len, pos,
	  sPrefix.Str(),
	  sSuffix.Str(),
	  sPrepend.Str());

 if ( pos==0 ) {
     sOut = sPath;
     return 0;
 }
 if ( pos+1<=len ) {
     sOut.CopyFromTo( sPath, pos+1, len );
     return 0;
 }
 pos = sPath.Find( '/' );
 if ( pos>=len ) {
     // This is a so called 'default new-name' (e.g. "@@output.htm")
     sOut = sPrefix;
     sOut.Add( "output" );
     sOut.AddString( sPrependToExtension );
     sOut.AddString( sSuffix );
     return 1;
 }

 if ( pos==1 ) {
     sPath.Delete( 1, 1 );
     len = sPath.Length();
     pos = sPath.FindBack( '/' );
 }
 sOut.CopyFromTo( sPath, pos+1 );

 return 0;
}

int do_unweb (gXHttpCont& aHttp, t_uint64 usedSize, FILE* fOut, FILE* fRepErr, sOptNetInfo& opt)
{
 int thisError;
 gString* pStr;
 unsigned size;
 char* str;

 ASSERTION(fOut!=nil,"fOut!=nil");
 if ( usedSize==0 ) {
     fprintf(fRepErr,"Empty buffer\n");
     return 0;
 }
 size = usedSize>=((t_uint64)MAX_UINT_UL) ? 0 : (unsigned)usedSize;
 if ( size==0 ) {
     fprintf(fRepErr,"Warn: buffer too wide (%lu octets)\n",(unsigned long)usedSize);
     return 0;
 }

 // Pad end with chr 0x0 is already made by aHttp buffer,
 // therefore we just consider +1 octet for this null chr.
 size++;
 pStr = new gString( size+1, '\0' );
 ASSERTION(pStr!=nil,"do_unweb(1)");
 // Copy quickly the buffer into pStr
 memcpy( pStr->Str(), aHttp.GetBaseBuffer().uBuf, (size_t)size );

 gUnweb unweb( *pStr, opt.isVerbose );

 delete pStr;
 thisError = unweb.Dump( fRepErr );

 unsigned y, n = unweb.coordSerial.N();
 for (y=1; y<=n; y++) {
     str = unweb.Str( y );
     fprintf(fOut,"%s\n",str);
 }

 if ( thisError!=0 ) {
     if ( opt.isVerbose ) {
	 unweb.coordParseErr.Report(fRepErr,true);
     }
     fprintf(fRepErr,"Error-code (%d): HTML errors: %d\n",thisError,unweb.nHtmlErrors);
 }

 return 0;
}
////////////////////////////////////////////////////////////
int thisFileInOut (gFileTemp& fT, FILE* fOut, sOptNetInfo& opt)
{
 int fHandle = fT.fHandle;
 t_uchar c;

 ASSERTION(fOut!=nil,"fOut!=nil (thisFileInOut)");
 if ( fT.Rewind()==false ) return -1;
 for ( ; read(fHandle,&c,1)==1; ) {
     fprintf(fOut,"%c",c);
 }
 return 0;
}
////////////////////////////////////////////////////////////
// Specific functions
////////////////////////////////////////////////////////////
int go_cmd_hostname (char* inHostName, sFileStreamCtrl& oStream, FILE* fRepErr, sOptNetInfo& opt, int aCmd)
{
 int error, thisError;
 gIpAddr ip;
 gURI tryURI( gURI::e_http );
 FILE* fOut = oStream.f;

 ASSERTION(fOut!=nil,"fOut!=nil");

 tryURI.SetString( inHostName );
 if ( strcmp( tryURI.Str(), tryURI.GetOriginalStr() )!= 0 ) {
     // e.g. hostname http://ABC.DOMAIN/rel_url/
     inHostName = tryURI.GetDomainStr();
     if ( opt.isVerbose ) fprintf(fOut,"%s\n",inHostName);
 }

 ip.GetHostByName( inHostName );
 thisError = ip.lastOpError;

 if ( ip.GetNetworkAddress()==0 ) thisError = 16;  // Some name-servers reply ok, and return IP 0.0.0.0

 if ( thisError!=0 ) {
     DBGPRINT_MIN("thisError=%d, lastOpError=%d [%s]\n",thisError,ip.lastOpError,ip.GetErrorStr());
     if ( opt.isVerbose ) {
	 fprintf(fRepErr,"Unable to determin host: %s\n",inHostName);
     }
 }
 else {
     if ( opt.doUnweb==false ) fprintf(fOut,"%s\n",(char*)ip.String());
 }

 error = thisError;

 return error;
}

int go_cmd_hostaddr (char* inHostAddr, sFileStreamCtrl& oStream, FILE* fRepErr, sOptNetInfo& opt, int aCmd)
{
 int error, thisError;
 gIpAddr ip( inHostAddr );
 gString sHost;
 FILE* fOut = oStream.f;

 ASSERTION(fOut!=nil,"fOut!=nil");

 thisError = ip.GetHostByAddr( sHost )!=0;

 if ( thisError!=0 ) {
     if ( opt.isVerbose ) {
	 fprintf(fRepErr,"Unable to determin IP for host: %s\n",inHostAddr);
	 if ( opt.isVeryVerbose )
	     fprintf(fOut,"%s\t:ERROR\n",inHostAddr);
     }
 }
 else {
     if ( opt.isVerbose && aCmd>0 ) fprintf(fOut,"%s\t",inHostAddr);
     fprintf(fOut,"%s\n",sHost.Str());
 }
 error = thisError;

 return error;
}

int go_cmd_connect (char* inHostName, sFileStreamCtrl& oStream, FILE* fRepErr, sOptNetInfo& opt, int aCmd)
{
 int error, thisError;
 gString sendStr;
 gTcpConnect connection( inHostName, opt.myPort );
 FILE* fOut = oStream.f;
 bool doExpectOnly = opt.isVeryMostVerbose;

 ASSERTION(fOut!=nil,"fOut!=nil");

 thisError = connection.lastOpError;
 if ( thisError!=0 ) {
     if ( opt.isVerbose ) {
	 fprintf(fRepErr,"Connection not established on port %u, error-code: %d (%s)\n",
		 (unsigned)opt.myPort,
		 thisError,
		 connection.GetErrorStr());
     }
     return error = 2;
 }

 if ( doExpectOnly==false ) {
     sendStr.Add( "GET " );
     sendStr.Add( "/" );
     sendStr.Add( ' ' );
     sendStr.Add( "HTTP/1.0" );
     sendStr.Add( "\r\n" );
     error = connection.Write( sendStr );
     if ( error!=0 ) return error;
     error = connection.Write( "\r\n" );
     if ( error!=0 ) {
	 if ( opt.isVerbose ) {
	     fprintf(fRepErr,"Unable to make HTTP request: %s\n",connection.GetErrorStr());
	 }
	 return 0; // Second error-call is not considered an error: remote host might have closed connection.
     }
 }
 if ( opt.isVeryVerbose ) {
     fprintf(fRepErr,"Target connectable.\n");
 }

 error = 0;
 if ( doExpectOnly ) {
     gString sResp;
     error = connection.ReadLine( sResp );
     DBGPRINT("DBG: ReadLine(%s): %d\n",sResp.Str(),error);
     printf("%s\n",sResp.Str());
 }

 return error;
}


int go_cmd_http_uri (gURI& aURI, sFileStreamCtrl& oStream, FILE* fRepErr, sOptNetInfo& opt)
{
 int thisError;
 char* strOriginal = aURI.GetOriginalStr();
 char* str = aURI.GetDomainStr();
 char* inHostName = aURI.IsValidDomain() ? str : nil;
 char* connectHostName = inHostName;
 FILE* fOut = oStream.f;
 FILE* fRepOut = stdout;
 gString sUriPath( aURI.GetPathStr() );
 gString sPath;
 bool isText;
 bool isPxyOk = true;
 t_gPort portURI = 0;
 gXHttpGeneric::eContentMethod method;

 method = opt.IsMethodGet() ? gXHttpGeneric::e_Get : gXHttpGeneric::e_Post;

 // If the path is empty (e.g. URI=google.com, instead of google.com/)
 // then assume '/' (root)
 if ( sUriPath.IsEmpty() ) sUriPath.Set( "/" );

 if ( opt.HasProxy() ) {
     inHostName = opt.GetProxyStr( isPxyOk, opt.proxy );
     sPath.Set( "http://" );
     sPath.Add( aURI.GetDomainStr() );
     if ( opt.myPort!=80 ) portURI = opt.myPort;
     opt.myPort = opt.proxy.port;
     if ( portURI!=0 ) {
	 // e.g.: http://moreira.dnsalias.net:82/abc/... (when --proxy option and -p are used)
	 sPath.Add( ":" );
	 sPath.Add( (unsigned)portURI );
     }
     sPath.Add( aURI.GetPathStr() );
     if ( isPxyOk==false ) {
	 fprintf(fRepErr,"Invalid proxy specified: %s\nFormat should be HOST:PORT\n",inHostName);
	 return 1;
     }
 }
 else {
     sPath = sUriPath;
 }

 if ( inHostName==nil || inHostName[0]==0 || connectHostName==nil || connectHostName[0]==0 ) {
     if ( str[0]==0 ) {
	 fprintf(fRepErr,"Empty URL: %s\n",strOriginal);
	 return 1;
     }
     fprintf(fRepErr,"Not a valid host: %s\n",str);
     return 1;
 }

 // Check auto-name (invent_new_name)
 DBGPRINT("DBG: fOut ok?%c, oStream.IsAutoNamed?%c\n",
	  ISyORn(fOut!=nil),
	  ISyORn(oStream.IsAutoNamed()));
 ASSERTION((fOut==nil && oStream.IsAutoNamed()==true) ||
	   (fOut!=nil && oStream.IsAutoNamed()==false),"cmd...uri(1)");
 if ( oStream.IsAutoNamed() ) {
     short iterName=0;
     bool isBadNewName;
     gString sPrefix( connectHostName );
     gString sSuffix( opt.sFileOut.Str()+2 );
     gString sPrepend;
     gString sNewName;

     sPrefix.Add( '@' );
     invent_new_name( sPath, sPrefix, sSuffix, sPrepend, sNewName );
     DBGPRINT("DBG: invented[1]: '%s'\n",sNewName.Str());
     gFileStat aStat( sNewName );
     isBadNewName = aStat.HasStat();
     if ( isBadNewName ) {
	 for (iterName=1; iterName>0 && iterName<10; iterName++) {
	     sNewName.SetEmpty();
	     sPrepend = (int)iterName;
	     sPrepend.Add( ".htm" );
	     invent_new_name( sPath, sPrefix, sSuffix, sPrepend, sNewName );
	     DBGPRINT("DBG: invented[2]: '%s'\n",sNewName.Str());
	     gFileStat newStat( sNewName );
	     if ( newStat.HasStat() ) {
		 if ( opt.isVerbose ) {
		     fprintf(fRepErr,"Skipping auto-named: %s\n",sNewName.Str());
		 }
	     }
	     else {
		 // File exists, therefore it is a good new-name!
		 iterName = -1;
		 isBadNewName = false;
	     }
	 }//end FOR
     }

     if ( isBadNewName ) {
	 fprintf(fRepErr,"Will not overwrite a auto-named file. Quit.\n");
	 return 1;
     }

     // Check if auto-named file is writable:
     fOut = oStream.f = fopen( sNewName.Str(), "wb" );
     if ( fOut==nil ) {
	 fprintf(fRepErr,"Unable to write auto-named file: %s\n",sNewName.Str());
	 return 1;
     }
     oStream.sName = sNewName;
     // New-name for file resolved finally
     if ( opt.isVerbose )
	 fprintf(fRepErr,"Using filename: %s\n",sNewName.Str());
 }

 //gDateTime aDtTm( atoi(strOriginal) );
 //printf("%d.%02d.%d %d:%d:%d wday=%d, yday=%d isdst=%d\n",
 //	aDtTm.year, aDtTm.month, aDtTm.day,
 //	aDtTm.hour, aDtTm.min, aDtTm.sec,
 //	aDtTm.wday, aDtTm.yday,	aDtTm.isdst);
 //t_stamp aStamp = aDtTm.GetTimeStamp();
 //gDateTime aDtTm2( 2004, 9, 26 );
 //printf("DELTA: secs since begining of day: %d, opError?%d, IsOk()?%d\n",aStamp-aDtTm2.GetTimeStamp(),aDtTm2.lastOpError,aDtTm2.IsOk());
 //;
 //gTimeStamp myStamp( aDtTm );
 //printf("DIFF: %d-%d, IsOk?%d\n",aStamp,myStamp.GetUInt(),myStamp.IsOk());

 gTcpConnect connection( inHostName, opt.myPort );
 gString sHost( connectHostName );

 thisError = connection.lastOpError;
 if ( thisError!=0 ) {
     if ( opt.isVerbose ) {
	 fprintf(fRepErr,"HTTP connection not established on port %u, error-code %d: %s%s\n",
		 (unsigned)opt.myPort,
		 thisError,
		 connection.GetErrorStr(),
		 connection.IsOk() ? "[]" : "\0");
     }
     return 2;
 }

 if ( opt.isVeryVerbose ) {
     fprintf(fRepErr,"HOST=>RHOST(%s):%s, connection OK\n",sHost.Str(),sPath.Str());
 }

 t_uint64 usedSize;
 t_uchar* uBuf;
 gString sReply;
 gNetHttpCont aHttp( connection );

 aHttp.doPace = opt.doPace;
 aHttp.SetProtocolVersion( opt.myProto.Str() );
 if ( opt.isVeryMostVerbose ) aHttp.fRepErr = stderr;

 if ( opt.sUserAgent.IsEmpty()==false ) {
     // The default of ghttp.o is really "Lynx ...",
     // and if empty is specified, no User-Agent is specified
     if ( opt.sUserAgent.Match("-") )
	 aHttp.strUserAgent.SetEmpty();
     else
	 aHttp.strUserAgent = opt.sUserAgent;
 }

 // Adjust added/specified requests
 aHttp.lReq.CopyRequest( opt.lReq );

 // Now go and get it!
 thisError = aHttp.GetContent( method, sHost, sPath, sReply )==false;
 isText = aHttp.IsText();
 opt.readOctets = aHttp.totalBytesRead;
 gBigBuffer::eBufferKind bKind;

 DBGPRINT_WEB("DBG_WEB: Req=(%s),(thisError=%d,int-opcode=%d, reply-htmlCode=%d:NotFound?%c{%s}): [%s]\n",
	      sPath.Str(),
	      thisError,
	      aHttp.ioOpErrCode,
	      aHttp.replyHeader.htmlCode,
	      ISyORn( aHttp.replyHeader.IsCodeNotFound() ),
	      aHttp.replyHeader.sHtmlCode.Str(),
	      sReply.Str());
#ifdef gGX_SIG_SUPPORT
 signal( GX_SIGALRM, NilSignalAlarmHandler );
#endif

 if ( opt.isVeryMostVerbose ) {
     //printf("SENT USER AGENT: '%s'\r\n",aHttp.strUserAgent.Str());
     printf("SENT TO HTTP-SERVER:\r\n"); aHttp.getHeaderL.Show( true ); printf(")\r\n\r\n");
 }
 if ( opt.isVeryVerbose ) {
     fprintf(fRepOut,"%s\n",sReply.Str());
 }

 if ( opt.sFileDumpReply.IsEmpty()==false ) {
     FILE* fDumpReply = fopen(opt.sFileDumpReply.Str(),"wb");
     if ( fDumpReply==nil ) {
	 fprintf(fRepErr,"Cannot write reply to file: %s\n",opt.sFileDumpReply.Str());
     }
     else {
	 fprintf(fDumpReply,"%s",sReply.Str());
	 fclose( fDumpReply );
     }
 }

 // Just copy statistics from aHttp object...
 short vIdx;
 opt.nStat = aHttp.nStat;
 ASSERTION(opt.nStat<=10,"aHttp.nStat<=10");
 for (vIdx=0; vIdx<opt.nStat; vIdx++) opt.vStat[vIdx].SetUInt( aHttp.vStat[vIdx].GetUInt() );

 // Any fatal errors?, then quit.
 DBGPRINT_MIN("DBG: thisError: %d, ioOpErrCode: %d\n",thisError,aHttp.ioOpErrCode);
 if ( thisError!=0 ) {
     if ( opt.isVerbose ) {
	 fprintf(fRepErr,"HTTP not complete: internal error-code: %d\n",aHttp.ioOpErrCode);
     }
 }

 int htmlCode = aHttp.replyHeader.htmlCode;
 usedSize = aHttp.GetBuffer().usedSize;
 uBuf = aHttp.GetBaseBuffer().uBuf;
 bKind = aHttp.GetBuffer().GetBufferKind();

 DBGPRINT_MIN("DBG: htmlCode: %d, usedSize: %lu, bKind=%d\n",
	      htmlCode,
	      (unsigned long)usedSize,
	      bKind);

 if ( opt.isVerbose ) {
     // 1xx: Informational
     // 2xx: Success
     // 3xx: Redirection
     // 4xx: Client error
     // 5xx: Server error
     if ( htmlCode>=100 ) {
	 if ( opt.isVeryVerbose==true || htmlCode<200 || htmlCode>=300 )
	 fprintf(fRepErr,"HTTP-CODE: %d (%s)\n",
		 htmlCode,
		 aHttp.replyHeader.kindsL.Str(1));
     }
 }

 DBGPRINT("DBG: isText?%c, usedSize=%lu base_size=%lu\n",
	  ISyORn(isText),
	  (unsigned long)usedSize,
	  (unsigned long)aHttp.GetBuffer().GetBaseSize());

 // Lines below are not ok, because it depends of the buffer type.
 //if ( opt.isVeryVerbose ) {
 //    if ( isText==true && usedSize>0 && uBuf[usedSize-1]!='\n' )
 //	 fprintf(fRepErr,"Warn: %s: No newline terminator.\n",strOriginal);
 //}

 // Moved file creation out of this function: before go_cmd calling,
 // except for auto-name.

 if ( opt.doUnweb ) {
     if ( bKind!=gBigBuffer::e_NormalRAM ) {
	 fprintf(stderr,"Sorry, no support for unweb & big-files\n");
	 return 32;
     }
     thisError = do_unweb( aHttp, usedSize, oStream.f, fRepErr, opt );
     oStream.DoClose();
     return thisError;
 }

 //
 // Show now!
 //
 unsigned k, nod, maxSize;

 thisError = 0;  //Redundant, but for clearness

 DBGPRINT_WEB("DBG_WEB: bKind=%d\n",(int)bKind); //Hint: use -DDEBUG_WEB on DevC++ "parameters" of your project.

 switch ( bKind ) {
 case gBigBuffer::e_NormalRAM:
     if ( isText ) {
	 fprintf(fOut,"%s",uBuf);
     }
     else {
	 for (k=0, maxSize=(unsigned)usedSize; k<=maxSize; k++) {
	     fprintf(fOut,"%c",uBuf[k]);
	 }
     }
 case gBigBuffer::e_NodesRAM:
     for (nod=0; nod<aHttp.GetBuffer().GetNumberNodes(); nod++) {
	 uBuf = aHttp.GetBuffer().GetNode(nod)->uBuf;
	 for (k=0, maxSize=aHttp.GetBuffer().GetNode(nod)->size; k<maxSize; k++)
	     fprintf(fOut,"%c",uBuf[k]);
     }
     break;
 case gBigBuffer::e_InFile:
     thisError = thisFileInOut( aHttp.GetBuffer().GetFile(), fOut, opt )!=0;
     if ( thisError!=0 ) {
	fprintf(fRepErr,"Unable to handle chunk.\n");
     }
 default:
     break;
 }

 if ( thisError==0 ) {
     if ( opt.doError4NotFound &&
	  (aHttp.replyHeader.IsCodeNotFound() || aHttp.replyHeader.IsCodeRedirect()) ) {
	 thisError = 4;
     }
     else {
	 oStream.DoClose();
     }
 }

 return thisError;
}

int go_cmd_http (gURI& aURI, sFileStreamCtrl& oStream, FILE* fRepErr, sOptNetInfo& opt, int aCmd)
{
 int thisError;
 char* strOriginal = aURI.GetOriginalStr();

 thisError = aURI.IsOkScheme()==false;
 if ( thisError!=0 ) {
     fprintf(fRepErr,"Invalid scheme: %s\n",strOriginal);
     return 1;
 }

 // If only a domain is given, without any slashes (e.g. gnetinfo http fuji),
 // then the URI domain is empty (!) and the path is fuji; this is o.k.,
 // as a URI can be just a relative name of a file;
 // we need to assume path as / and the domain is the string itself, as the user intended.
 gString sTemp( aURI.GetPathStr() );
 if ( sTemp.Match( strOriginal ) ) {
     sTemp.Add( '/' );
     gURI bURI( gURI::e_http );
     bURI.SetString( sTemp.Str() );
     thisError = go_cmd_http_uri( bURI, oStream, fRepErr, opt );
 }
 else {
     thisError = go_cmd_http_uri( aURI, oStream, fRepErr, opt );
 }

 return thisError;
}
////////////////////////////////////////////////////////////
int go_cmd (gArg& arg, sFileStreamCtrl& oStream, FILE* fRepErr, sOptNetInfo& opt, int aCmd)
{
 int error = 0, thisError = -1, countIter = 0;
 char* str;
 unsigned i, n = arg.N();
 t_gTicElapsed cpuTics;
 gTimerTic tic;
 FILE* fStat = stderr;

 for (i=1; i<=n; i++) {
     str = arg.Str( i );
     if ( str[0]==0 ) continue;
     if ( opt.isVeryVerbose ) fprintf(fRepErr,":::%s\n",str);
     tic.Start();
     switch ( aCmd ) {
     case 1:
	 thisError = go_cmd_hostname( str, oStream, fRepErr, opt, n>1 );
	 break;
     case 2:
	 thisError = go_cmd_hostaddr( str, oStream, fRepErr, opt, n>1 );
	 break;
     case 4:
	 thisError = go_cmd_connect( str, oStream, fRepErr, opt, aCmd );
	 break;
     case 5:
     case 6:
	 opt.isGetMethod = aCmd==5;
	 opt.myURI.SetString( str );
	 thisError = go_cmd_http( opt.myURI, oStream, fRepErr, opt, aCmd );
	 DBGPRINT_WEB("DBG: go_cmd_http result(%s)=%d\n",opt.myURI.Str(),thisError);
	 break;
     default:
	 ASSERTION_FALSE("Wrong cmd");
     }
     cpuTics = tic.CpuTics();
     if ( opt.doShowStats ) {
	 t_uint32 elapsedMilisec;
	 t_uint32 inOctets = opt.GetInOctets();
	 t_uint32 paceMade;
	 float octPerSec;
	 elapsedMilisec = tic.GetMilisec();
	 octPerSec = (float)inOctets / (elapsedMilisec==0 ? 0.001 : (float)elapsedMilisec) * 1000.0;
	 fprintf(fStat,"Stats (in miliseconds):\nTotal: CPU_used=%0.0f ms, elapsed=%u ms\n",
		(float)tic.GetMilisecsFromTics( cpuTics ),
		elapsedMilisec);
	 paceMade = opt.vStat[3].GetUInt();
	 if ( opt.isVerbose==true || inOctets>1000 ) {
	     fprintf(fStat,"Total octets: %u\n",inOctets);
	     if ( opt.nStat>2 ) {
		 fprintf(fStat, "Head reply: %u ms, content reply: %u ms, client pace: %u ms\n",
			 opt.vStat[1].GetUInt(),
			 opt.vStat[2].GetUInt(),
			 paceMade);
	     }
	     fprintf(fStat,"Throughput (Octets/s): in=%0.0f  (Kbit/s): %0.0f%s\n",
		     octPerSec,
		     octPerSec*8.0/1000.0,
		     elapsedMilisec < 1000 || inOctets < 1000 ? "(?)" : "\0");
	 }
     }
     countIter++;
     if ( thisError!=0 ) {
	 if ( opt.isVerbose ) fprintf(fRepErr,"Error (%d) handling: %s\n",thisError,str);
	 if ( error==0 ) error = thisError;
     }
 }

 if ( countIter==0 ) {
     fprintf(stderr,"No host specified.\n");
     return 2;
 }

 return error;
}
////////////////////////////////////////////////////////////
int go (char** argv, char** envp, int& result)
{
 int error, thisError = -1;
 gArg arg( argv, envp );
 sOptNetInfo opt;
 int iVal;

 unsigned n;
 FILE* fRepErr = stderr;

 result = 0;

 arg.AddParams( 1, "-vv|--verbose -h|--help --version\
 -d|--dos-mode\
 -f|--force\
 -o:%s|--output:%s\
 -p:%u|--port:%u\
 -P:%s|--protocol:%s\
 -r:%s|--request:%s\
 -t:%d|--timeout:%d\
 -u:%s|--user-agent:%s\
 -x:%s|--proxy:%s\
 -~:%s|--dump-reply:%s\
 --stats\
 --unweb\
 --no-pace\
 --not-found-error\
 --most-verbose\
" );
 // Parse command line
 error = arg.FlushParams();
 n = arg.N();
 arg.FindOptionOccurr( "verbose", opt.isVerbose, opt.isVeryVerbose );
 opt.isVeryMostVerbose = arg.FindOption( "most-verbose" );

 if ( arg.FindOption('h') || error!=0 ) {
     print_help( arg.Program() );
     return 0;
 }
 if ( arg.FindOption("version") ) {
     print_version( arg.Program() );
     return 0;
 }

 opt.doDosMode = arg.FindOption("dos-mode");
 opt.doForce = arg.FindOption("force");
 opt.doUnweb = arg.FindOption("unweb");
 opt.doPace = arg.FindOption("no-pace")==false;
 opt.doShowStats = arg.FindOption("stats");
 opt.doError4NotFound = arg.FindOption("not-found-error");

 if ( arg.FindOption("port",iVal) ) {
     opt.myPort = (t_gPort)iVal;
 }

 if ( arg.FindOption("timeout",iVal) ) {
     opt.secTimeout = (unsigned)iVal;
     if ( iVal<0 ) {
	 fprintf(fRepErr,"Invalid timeout specified: must use a non-negative value.\n");
	 return 1;
     }
 }

 arg.FindOption( 'o', opt.sFileOut );
 arg.FindOption( 'P', opt.myProto );
 arg.FindOption( 'x', opt.myProxy );

 arg.FindOption( '~', opt.sFileDumpReply ); // --dump-reply option used

 if ( arg.FindOption( 'r', opt.sFileRequest ) ) {
     gHttpRequestList lReq;
     int code = parse_request_file_input( fRepErr, opt.sFileRequest, lReq );
     if ( code ) {
	 fprintf(fRepErr,"Invalid request file input (error-code %d): %s\n",
		 code,
		 opt.sFileRequest.Str());
	 return 1;
     }
     /* --- debug:
     unsigned i, n=lReq.N();
     for (i=1; i<=n; i++) printf("%s\n",lReq.Str(i));
     printf("DBG: ^^^---\n\tcode=%d (head-lines#%u, length#%ld)\n\n",
	    code,
	    n,
	    (long)lReq.iContentLength);
     printf("DBG: ---vvv\n"); lReq.lText.Show(); printf("DBG: ---^^^\n");
     */
     opt.lReq.CopyRequest( lReq );
 }

 arg.FindOption( 'u', opt.sUserAgent ); // e.g.: Lynx/2.8.4rel.1 ...

 if ( n==0 ) {
     fprintf(stderr,"No command.\n");
     return 0;
 }
 // parsing nearly ends...
 gString sCmd( arg.Str( 1 ) );
 char* cmdStr = sCmd.Str();
 arg.Delete( 1, 1 );  // First string of list is the command

 // Adjust output file
 sFileStreamCtrl* xStream = new sFileStreamCtrl( opt.sFileOut );
 ASSERTION(xStream!=nil,"xStream!=nil");
 if ( xStream->IsAutoNamed() )
     xStream->f = nil;
 else
     xStream->f = stdout;
 ;
 if ( xStream->sName.IsEmpty()==false ) {
     // Here the user specified an output file, *not* auto-named
     ;
     // Prevent overwrite if file exists
     gFileStat fstatExist( opt.sFileOut );
     if ( opt.doForce==false && fstatExist.HasStat()==true ) {
	 fprintf(fRepErr,"Will not overwrite existing file: %s\n",opt.sFileOut.Str());
	 xStream->DoClose();
	 delete xStream;
	 return result = 1;
     }
     xStream->f = fopen( xStream->sName.Str(), "wb" );
     if ( xStream->f==nil ) {
	 fprintf(fRepErr,"Unable to write output to file: %s\n",xStream->sName.Str());
	 xStream->DoClose();
	 delete xStream;
	 return 1;
     }
 }

 glob_fRepErr = opt.isVerbose ? stderr : nil;

 // Prepare timeouts
#ifdef gGX_SIG_SUPPORT
 signal( GX_SIGALRM, NetSignalAlarmHandler );
 if ( opt.secTimeout )
     alarm( opt.secTimeout );
#endif

 // Processing main command
 if ( strcmp(cmdStr,"hostname")==0 ) {
     thisError = go_cmd( arg, *xStream, fRepErr, opt, 1 );
     xStream->DoClose();
 }
 if ( strcmp(cmdStr,"hostaddr")==0 ) {
     thisError = go_cmd( arg, *xStream, fRepErr, opt, 2 );
     xStream->DoClose();
 }
 if ( strcmp(cmdStr,"connect")==0 ) {
     thisError = go_cmd( arg, *xStream, fRepErr, opt, 4 );
     xStream->DoClose();
 }
 if ( strcmp(cmdStr,"http")==0 ) {
     thisError = go_cmd( arg, *xStream, fRepErr, opt, 5 );
 }
 if ( strcmp(cmdStr,"post")==0 ) {
     thisError = go_cmd( arg, *xStream, fRepErr, opt, 6 );
 }

 DBGPRINT_WEB("go_cmd returned %d\n",thisError);

 if ( thisError==-1 ) {
     opt.myURI.SetString( cmdStr );
     arg.Add( cmdStr );
     // Command http://XYZ is accepted
     thisError = opt.myURI.lastOpError;
     DBGPRINT("ERR: %d (myURI.IsOkScheme()=%d), spec=%d\n",thisError,opt.myURI.IsOkScheme(),opt.HasSpecURI());
     if ( thisError==0 && opt.HasSpecURI()==true ) {
	 thisError = go_cmd( arg, *xStream, fRepErr, opt, 5 );
     }
     else {
	 fprintf(stderr,"Invalid command: %s\n",cmdStr);
	 thisError = 1;
     }
 }

#ifdef gGX_SIG_SUPPORT
 signal( GX_SIGALRM, NilSignalAlarmHandler );
#endif

 delete xStream;
 result = thisError;

 return thisError;
}
////////////////////////////////////////////////////////////
int main (int argc, char** argv, char** envp)
{
 int error, result=0;

 gINIT;

#ifdef gDOS_SPEC
 WSADATA wsaData;
 error = WSAStartup (MAKEWORD(2,2), &wsaData)!=NO_ERROR;
 if ( error!=0 ) return 1;
#endif //gDOS_SPEC

 error = go( argv, envp, result );

 gEND;

 DBGPRINT_MIN("go: %d, result=%d\n",error,result);

 return result;
}

